// AutoUpdater.h: interface for the CAutoUpdater class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AUTOUPDATER_H
#define AUTOUPDATER_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Wininet.h>

#define LOCATION_UPDATE_FILE_CHECK _T("update.txt")
#define LOCATION_UPDATE_FILE_ZIP _T("stp_exe.php")

class CAutoUpdater
{
public:
	CAutoUpdater();
	virtual ~CAutoUpdater();

	enum ErrorType
	{
		Success,
		InternetConnectFailure,
		InternetSessionFailure,
		ConfigDownloadFailure,
		FileDownloadFailure,
		NoExecutableVersion,
		UpdateNotRequired,
		UpdateNotComplete
	};

	ErrorType CheckForUpdate(LPCTSTR UpdateServerURL);	
	HINTERNET GetSession(CString& URL);

	bool InternetOkay();
	bool DownloadConfig(HINTERNET hSession, BYTE* pBuf, DWORD bufSize);
	bool DownloadFile(HINTERNET hSession, LPCTSTR localFile);

	CString GetFileVersion(LPCTSTR file);
	int CompareVersions(CString ver1, CString ver2);
	bool IsDigits(CString text);
	CString GetExecutable();
	bool Switch(CString executable, CString update, bool WaitForReboot);

private:
	HINTERNET hInternet;
};

#endif