// EqualizerDlg.cpp : implementation file
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "EqualizerDlg.h"
#include "MainWnd.h"
#include "MainHelper.h"
#include "paramlist.h"
#include "In\CommonFunc.h"
#include ".\equalizerdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern float last_srate;
extern void equ_makeTable(float* lbc, float* rbc, paramlist*, float fs);

extern float lbands[];
extern float rbands[];
extern paramlist paramroot;
paramlist lastparamroot;

int lslpos[19], rslpos[19], last_lslpos[19], last_rslpos[19];
int locklr = 1, not_applied = 0;
int last_param_index = 0;
extern CString autoloadfile;

int freqs[] =
{
	55, 77, 110, 156, 220, 311, 440, 622, 880, 1244, 1760, 2489, 3520, 4978, 7040, 9956, 14080, 19912
};

CBitSlider* lsl[19], * rsl[19];

CEqualizerDlg::CEqualizerDlg() : CDialog(CEqualizerDlg::IDD)
{
	m_ch_dither = FALSE;
	m_ch_pleft = FALSE;
	m_ch_pright = FALSE;
	m_ch_enable = FALSE;
	m_ch_lock = FALSE;
}

CEqualizerDlg::~CEqualizerDlg()
{
	EqualizerDlg = NULL;
}

CEqualizerDlg* CEqualizerDlg::getInstance()
{
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
		EqualizerDlg->SaveWindowPosAndDestroy();
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
	{
		delete EqualizerDlg;
		EqualizerDlg = NULL;
	}
	if (EqualizerDlg == NULL)
	{
		EqualizerDlg = new CEqualizerDlg();
		EqualizerDlg->Create(CEqualizerDlg::IDD);
	}
	else
		EqualizerDlg->SetFocus();
	return EqualizerDlg;
}

IMPLEMENT_MENUXP(CEqualizerDlg, CDialog)

BEGIN_MESSAGE_MAP(CEqualizerDlg, CDialog)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_BUT_LOAD, OnButLoad)
	ON_BN_CLICKED(IDOK, OnButOk)
	ON_BN_CLICKED(IDC_BUT_SAVE, OnButSave)
	ON_BN_CLICKED(IDC_ENABLE, OnChEnable)
	ON_BN_CLICKED(IDC_CH_LOCK, OnChLock)
	ON_BN_CLICKED(IDC_BUT_UP, OnButUp)
	ON_BN_CLICKED(IDC_BUT_DOWN, OnButDown)
	ON_BN_CLICKED(IDC_BUT_APPLY, OnButApply)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUT_PNEW, OnButPnew)
	ON_BN_CLICKED(IDC_BUT_PDEL, OnButPdel)
	ON_BN_CLICKED(IDC_CH_DITHER, OnChDither)
	ON_LBN_SELCHANGE(IDC_LIST_PARAM, OnSelchangeListParam)
	ON_EN_KILLFOCUS(IDC_ED_PLOW, OnKillfocusEdPlow)
	ON_EN_KILLFOCUS(IDC_ED_PUP, OnKillfocusEdPup)
	ON_EN_KILLFOCUS(IDC_ED_GAIN, OnKillfocusEdGain)
	ON_BN_CLICKED(IDC_CH_PLEFT, OnChPleft)
	ON_BN_CLICKED(IDC_CH_PRIGHT, OnChPright)
	ON_WM_CLOSE()
	ON_WM_SYSCOMMAND()
	ON_MENUXP_MESSAGES()
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg message handlers

void CEqualizerDlg::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUT_PNEW, m_but_pnew);
	DDX_Control(pDX, IDC_BUT_PDEL, m_but_pdelete);
	DDX_Control(pDX, IDC_BUT_LOAD, m_but_load);
	DDX_Control(pDX, IDC_BUT_SAVE, m_but_save);
	DDX_Control(pDX, IDC_BUT_UP, m_but_up);
	DDX_Control(pDX, IDC_BUT_DOWN, m_but_down);
	DDX_Control(pDX, IDOK, m_but_ok);
	DDX_Control(pDX, IDCANCEL, m_but_cancel);
	DDX_Control(pDX, IDC_CH_PRIGHT, m_ch_pright2);
	DDX_Control(pDX, IDC_CH_PLEFT, m_ch_pleft2);
	DDX_Control(pDX, IDC_CH_DITHER, m_ch_dither2);
	DDX_Control(pDX, IDC_LIST_PARAM, m_list_param);
	DDX_Control(pDX, IDC_ED_PUP, m_ed_pup);
	DDX_Control(pDX, IDC_ED_PLOW, m_ed_plow);
	DDX_Control(pDX, IDC_ED_GAIN, m_ed_gain);
	DDX_Control(pDX, IDC_BUT_APPLY, m_but_apply);
	DDX_Control(pDX, IDC_CH_LOCK, m_ch_lock2);
	DDX_Control(pDX, IDC_ENABLE, m_ch_enable2);
	DDX_Control(pDX, IDC_ED_TARGET, m_ed_target);
	DDX_Control(pDX, IDC_SL_RPRE, m_rpre);
	DDX_Control(pDX, IDC_SL_R9, m_r9);
	DDX_Control(pDX, IDC_SL_R8, m_r8);
	DDX_Control(pDX, IDC_SL_R7, m_r7);
	DDX_Control(pDX, IDC_SL_R6, m_r6);
	DDX_Control(pDX, IDC_SL_R5, m_r5);
	DDX_Control(pDX, IDC_SL_R4, m_r4);
	DDX_Control(pDX, IDC_SL_R3, m_r3);
	DDX_Control(pDX, IDC_SL_R2, m_r2);
	DDX_Control(pDX, IDC_SL_R18, m_r18);
	DDX_Control(pDX, IDC_SL_R17, m_r17);
	DDX_Control(pDX, IDC_SL_R16, m_r16);
	DDX_Control(pDX, IDC_SL_R15, m_r15);
	DDX_Control(pDX, IDC_SL_R14, m_r14);
	DDX_Control(pDX, IDC_SL_R13, m_r13);
	DDX_Control(pDX, IDC_SL_R12, m_r12);
	DDX_Control(pDX, IDC_SL_R11, m_r11);
	DDX_Control(pDX, IDC_SL_R10, m_r10);
	DDX_Control(pDX, IDC_SL_R1, m_r1);
	DDX_Control(pDX, IDC_SL_L9, m_l9);
	DDX_Control(pDX, IDC_SL_L8, m_l8);
	DDX_Control(pDX, IDC_SL_L7, m_l7);
	DDX_Control(pDX, IDC_SL_L6, m_l6);
	DDX_Control(pDX, IDC_SL_L5, m_l5);
	DDX_Control(pDX, IDC_SL_L4, m_l4);
	DDX_Control(pDX, IDC_SL_L3, m_l3);
	DDX_Control(pDX, IDC_SL_L2, m_l2);
	DDX_Control(pDX, IDC_SL_L18, m_l18);
	DDX_Control(pDX, IDC_SL_L17, m_l17);
	DDX_Control(pDX, IDC_SL_L16, m_l16);
	DDX_Control(pDX, IDC_SL_L15, m_l15);
	DDX_Control(pDX, IDC_SL_L14, m_l14);
	DDX_Control(pDX, IDC_SL_L13, m_l13);
	DDX_Control(pDX, IDC_SL_L12, m_l12);
	DDX_Control(pDX, IDC_SL_L11, m_l11);
	DDX_Control(pDX, IDC_SL_L10, m_l10);
	DDX_Control(pDX, IDC_SL_L1, m_l1);
	DDX_Control(pDX, IDC_SL_LPRE, m_lpre);
	DDX_Check(pDX, IDC_CH_LOCK, m_ch_lock);
	DDX_Check(pDX, IDC_ENABLE, m_ch_enable);
	DDX_Check(pDX, IDC_CH_DITHER, m_ch_dither);
	DDX_Check(pDX, IDC_CH_PLEFT, m_ch_pleft);
	DDX_Check(pDX, IDC_CH_PRIGHT, m_ch_pright);
}

void setBandsFromSlpos(void)
{
	int i;
	float lpreamp = lslpos[0] == 96 ? (float)0.0 : (float)pow((double)10, (double)lslpos[0] / -20.0);
	float rpreamp = rslpos[0] == 96 ? (float)0.0 : (float)pow((double)10, (double)rslpos[0] / -20.0);

	for (i = 0; i < 18; i++)
	{
		lbands[i] = lslpos[i + 1] == 96 ? (float)0.0 : lpreamp * (float)pow((double)10, (double)lslpos[i + 1] / -20.0);
		rbands[i] = rslpos[i + 1] == 96 ? (float)0.0 : rpreamp * (float)pow((double)10, (double)rslpos[i + 1] / -20.0);
		if(lbands[i] != rbands[i])
		{
			locklr = 0;
		}
	}

	equ_makeTable(lbands, rbands, &paramroot, last_srate);
}

void CEqualizerDlg::sort_param(void)
{
	paramlistelm* selelm = NULL,* lastelm = NULL;
	int sel = m_list_param.GetCurSel();
	if (sel != LB_ERR)
		selelm = (paramlistelm *)m_list_param.GetItemDataPtr(sel);
	if (last_param_index != -1)
		lastelm = (paramlistelm *)m_list_param.GetItemDataPtr(last_param_index);

	m_list_param.ResetContent();
	paramroot.sortelm();

	for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
	{
		int indx = m_list_param.AddString(e->getString());
		m_list_param.SetItemDataPtr(indx, e);
		if (selelm == e)
			sel = indx;
		if (lastelm == e)
			last_param_index = indx;
	}

	if (sel != LB_ERR)
	{
		m_list_param.SetCurSel(sel);
	}
}

void CEqualizerDlg::set_paramlistelm_from_gui(int index)
{
	int sel = m_list_param.GetCurSel();
	paramlistelm* e = (paramlistelm*)m_list_param.GetItemDataPtr(index);

	e->left = m_ch_pleft2.GetCheck();	
	e->right = m_ch_pright2.GetCheck();	

	CString str;
	m_ed_pup.GetWindowText(str);
	e->upper = (float)_tstof(str);
	m_ed_plow.GetWindowText(str);
	e->lower = (float)_tstof(str);
	m_ed_gain.GetWindowText(str);
	e->gain = (float)_tstof(str);

	m_list_param.DeleteString(index);
	m_list_param.InsertString(index, e->getString());
	m_list_param.SetItemDataPtr(index, e);

	m_list_param.SetCurSel(sel);

	not_applied = 1;
	
	sort_param();
}

void CEqualizerDlg::set_gui_from_paramlistelm(int index)
{
	if (index == -1)
	{
		m_ed_plow.SetWindowText(_T(""));
		m_ed_plow.EnableWindow(FALSE);
		m_ed_pup.SetWindowText(_T(""));
		m_ed_pup.EnableWindow(FALSE);
		m_ed_gain.SetWindowText(_T(""));
		m_ed_gain.EnableWindow(FALSE);
		m_ch_pleft2.SetCheck(FALSE);
		m_ch_pleft2.EnableWindow(FALSE);
		m_ch_pright2.SetCheck(FALSE);
		m_ch_pright2.EnableWindow(FALSE);
		return;
	}

	m_ed_plow.EnableWindow(TRUE);
	m_ed_pup.EnableWindow(TRUE);
	m_ed_gain.EnableWindow(TRUE);
	m_ch_pleft2.EnableWindow(TRUE);
	m_ch_pright2.EnableWindow(TRUE);

	int sel = m_list_param.GetCurSel();
	paramlistelm* e = (paramlistelm*)m_list_param.GetItemDataPtr(index);

	m_ch_pleft2.SetCheck(e->left);
	m_ch_pright2.SetCheck(e->right);

	CString str;
	str.Format(_T("%.10g"), e->upper);
	m_ed_pup.SetWindowText(str);

	str.Format(_T("%.10g"), e->lower);
	m_ed_plow.SetWindowText(str);

	str.Format(_T("%.10g"), e->gain);
	m_ed_gain.SetWindowText(str);

	m_list_param.SetCurSel(sel);
}

void CEqualizerDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int i, l, r;

	l = lsl[0]->GetPos();
	r = rsl[0]->GetPos();

	if (lslpos[0] != l)
	{
		CString str;
		if (l == 96)
			str = m_Helper.MyLoadString(IDS_LPREAMPCUT);
		else
			str.Format(m_Helper.MyLoadString(IDS_LPREAMPDB), -l);
		m_ed_target.SetWindowText(str);
	}

	if (rslpos[0] != r)
	{
		CString str;
		if (r == 96)
			str = m_Helper.MyLoadString(IDS_RPREAMPCUT);
		else
			str.Format(m_Helper.MyLoadString(IDS_RPREAMPDB), -r);
		m_ed_target.SetWindowText(str);
	}

	if (locklr)
	{
		if (lslpos[0] != l)
		{
			r = l; rsl[0]->SetPos(l);
		}
		if (rslpos[0] != r)
		{
			l = r; lsl[0]->SetPos(r);
		}
	}

	lslpos[0] = l;
	rslpos[0] = r;

	for (i = 0; i < 18; i++)
	{
		l = lsl[i + 1]->GetPos();
		r = rsl[i + 1]->GetPos();

		if (lslpos[i + 1] != l)
		{
			CString str;
			if (l == 96)
				str.Format(m_Helper.MyLoadString(IDS_LHZCUT), freqs[i]);
			else
				str.Format(m_Helper.MyLoadString(IDS_LHZDB), freqs[i], -l);
			m_ed_target.SetWindowText(str);
		}

		if (rslpos[i + 1] != r)
		{
			CString str;
			if (r == 96)
				str.Format(m_Helper.MyLoadString(IDS_RHZCUT), freqs[i]);
			else
				str.Format(m_Helper.MyLoadString(IDS_RHZDB), freqs[i], -r);
			m_ed_target.SetWindowText(str);
		}

		if (locklr)
		{
			if (lslpos[i + 1] != l)
			{
				r = l; rsl[i + 1]->SetPos(l);
			}
			if (rslpos[i + 1] != r)
			{
				l = r; lsl[i + 1]->SetPos(r);
			}
		}

		lslpos[i + 1] = l;
		rslpos[i + 1] = r;
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

	not_applied = 1;
}

void load_from(CStringArray *listString)
{
	TCHAR buf[256];
	CString tmp = listString->GetAt(0);

	if(tmp == _T(""))
	{
		return;
	}

	_tcscpy(buf, tmp.GetString());

	if (_stscanf(buf, _T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"), &lslpos[0], &lslpos[1], &lslpos[2], &lslpos[3], &lslpos[4], &lslpos[5], &lslpos[6], &lslpos[7], &lslpos[8], &lslpos[9], &lslpos[10], &lslpos[11], &lslpos[12], &lslpos[13], &lslpos[14], &lslpos[15], &lslpos[16], &lslpos[17], &lslpos[18], &rslpos[0], &rslpos[1], &rslpos[2], &rslpos[3], &rslpos[4], &rslpos[5], &rslpos[6], &rslpos[7], &rslpos[8], &rslpos[9], &rslpos[10], &rslpos[11], &rslpos[12], &rslpos[13], &rslpos[14], &rslpos[15], &rslpos[16], &rslpos[17], &rslpos[18]) != 38)
	{
		::MessageBox(NULL, _T("Format error"), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
		// error
	}

	delete paramroot.elm;
	paramroot.elm = NULL;
	paramlistelm** p;
	int i = 1;

	for (p = &paramroot.elm; i < listString->GetSize(); p = &(*p)->next)
	{
		float lower, upper, gain;
		int left, right, r;

		tmp = listString->GetAt(i);

		_tcscpy(buf, tmp.GetString());

		r = _stscanf(buf, _T("%g %g %g %d %d"), &upper, &lower, &gain, &left, &right);
		if (r == 0 || r == EOF)
			break;
		if (r != 5)
		{
			wsprintf(buf, _T("Format error 2 (%d)"), r);
			::MessageBox(NULL, buf, _T("STP"), MB_OK | MB_ICONEXCLAMATION);
			break;
		}

		*p = new paramlistelm;
		(*p)->lower = lower;
		(*p)->upper = upper;
		(*p)->gain = gain;
		(*p)->left = left;
		(*p)->right = right;
		i++;
	}
}

void load_fromFilename(CString filename)
{
	CStdioFile f;

	if (!f.Open(filename, CFile::modeRead))
	{
		if(filename != _T(""))
		{
			::MessageBox(NULL, m_Helper.MyLoadString(IDS_CANTOPEN), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
		}
		return;
	}

	CStringArray listString;

	CString tmp;

	while(f.ReadString(tmp))
	{
		listString.Add(tmp);
	}

	f.Close();

	load_from(&listString);
}

CStringArray *save_to()
{
	CStringArray *result = new CStringArray();
	CString buf;

	buf.Format(_T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n"), lslpos[0], lslpos[1], lslpos[2], lslpos[3], lslpos[4], lslpos[5], lslpos[6], lslpos[7], lslpos[8], lslpos[9], lslpos[10], lslpos[11], lslpos[12], lslpos[13], lslpos[14], lslpos[15], lslpos[16], lslpos[17], lslpos[18], rslpos[0], rslpos[1], rslpos[2], rslpos[3], rslpos[4], rslpos[5], rslpos[6], rslpos[7], rslpos[8], rslpos[9], rslpos[10], rslpos[11], rslpos[12], rslpos[13], rslpos[14], rslpos[15], rslpos[16], rslpos[17], rslpos[18]);

	result->Add(buf);

	for (paramlistelm* p = paramroot.elm; p != NULL; p = p->next)
	{
		buf.Format(_T("%.20g %.20g %.20g %d %d\n"), (double)p->upper, (double)p->lower, (double)p->gain, (int)p->left, (int)p->right);
		result->Add(buf);
	}
	return result;
}

void CEqualizerDlg::OnButLoad()
{
	CFileDialog filedialog(TRUE, _T("eq"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENEQ));

	if (filedialog.DoModal() == IDCANCEL)
	{
		return;
	}

	load_fromFilename(filedialog.GetPathName());

	for (int i = 0; i < 19; i++)
	{
		lsl[i]->SetPos(lslpos[i]);
		rsl[i]->SetPos(rslpos[i]);
	}

	m_list_param.ResetContent();

	for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
	{
		int indx = m_list_param.AddString(e->getString());
		m_list_param.SetItemDataPtr(indx, e);
	}

	setBandsFromSlpos();

	not_applied = 0;
}

void CEqualizerDlg::OnButOk()
{
	CDialog::OnOK();

	for (int i = 0; i < 19; i++)
	{
		last_lslpos[i] = lslpos[i];
		last_rslpos[i] = rslpos[i];
	}

	lastparamroot.copy(paramroot);
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnButSave()
{
	CFileDialog filedialog(TRUE, _T("eq"), _T(""), OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_OPENEQ));

	if (not_applied)
	{
		not_applied = 0;
		setBandsFromSlpos();
	}

	if (filedialog.DoModal() == IDCANCEL)
	{
		return;
	}

	CStdioFile f;

	if (!f.Open(filedialog.GetPathName(), CFile::modeCreate | CFile::modeWrite))
	{
		::MessageBox(NULL, m_Helper.MyLoadString(IDS_CANTOPEN), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
		// error
		return;
	}

	CStringArray *buf = save_to();

	for(int i = 0; i < buf->GetSize(); i++)
	{
		f.WriteString(buf->GetAt(i));
	}
	delete buf;
	f.Close();
}

BOOL CEqualizerDlg::OnInitDialog()
{
	int i;
	extern int enable, dither;

	m_ch_enable = enable;
	m_ch_dither = dither;
	m_ch_lock = locklr;

	CDialog::OnInitDialog();
	m_Helper.translateWindowText(this, IDD_EQUALIZER_DIALOG);
	m_Helper.translateDlgItemText(this, IDC_GRAPHIC_EQUALIZER);
	m_Helper.translateDlgItemText(this, IDC_LLEFT);
	m_Helper.translateDlgItemText(this, IDC_LRIGHT);
	m_Helper.translateDlgItemText(this, IDC_CH_LOCK);
	m_Helper.translateDlgItemText(this, IDC_BUT_UP);
	m_Helper.translateDlgItemText(this, IDC_BUT_DOWN);
	m_Helper.translateDlgItemText(this, IDC_BUT_LOAD);
	m_Helper.translateDlgItemText(this, IDC_BUT_SAVE);
	m_Helper.translateDlgItemText(this, IDC_BUT_APPLY);
	m_Helper.translateDlgItemText(this, IDCANCEL);
	m_Helper.translateDlgItemText(this, IDC_ENABLE);
	m_Helper.translateDlgItemText(this, IDC_CH_DITHER);
	m_Helper.translateDlgItemText(this, IDC_LPARAMETRIC_EQUALIZER);
	m_Helper.translateDlgItemText(this, IDC_BUT_PNEW);
	m_Helper.translateDlgItemText(this, IDC_BUT_PDEL);
	m_Helper.translateDlgItemText(this, IDC_CH_PLEFT);
	m_Helper.translateDlgItemText(this, IDC_CH_PRIGHT);
	m_Helper.translateDlgItemText(this, IDC_LLOW_FREQ);
	m_Helper.translateDlgItemText(this, IDC_LUPPER_FREQ);
	m_Helper.translateDlgItemText(this, IDC_LGAIN);
	m_Helper.translateDlgItemText(this, IDC_LHZ1);
	m_Helper.translateDlgItemText(this, IDC_LHZ2);
	m_Helper.translateDlgItemText(this, IDC_LDB);
	m_Helper.translateDlgItemText(this, IDC_LCHANNEL);

	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	CRect rect1, rect2;


	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	GetWindowRect(&rect2);
	if (pMainFrame->EqualizerX == -1000)
		pMainFrame->EqualizerX = (rect1.right - (rect2.right - rect2.left)) / 2;
	if (pMainFrame->EqualizerY == -1000)
		pMainFrame->EqualizerY = (rect1.bottom - (rect2.bottom - rect2.top)) / 2;
	if (pMainFrame->EqualizerX < 0)
		pMainFrame->EqualizerX = 0;
	if (pMainFrame->EqualizerY < 0)
		pMainFrame->EqualizerY = 0;
	if (pMainFrame->EqualizerX + (rect2.right - rect2.left) > rect1.right)
		pMainFrame->EqualizerX = rect1.right - (rect2.right - rect2.left);
	if (pMainFrame->EqualizerY + (rect2.bottom - rect2.top) > rect1.bottom)
		pMainFrame->EqualizerY = rect1.bottom - (rect2.bottom - rect2.top);
	SetWindowPos(NULL, pMainFrame->EqualizerX, pMainFrame->EqualizerY, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, m_Helper.MyLoadString(IDS_ALWAYSONTOP));
	}
	if (pMainFrame->EQOnTop == 1)
	{
		pSysMenu->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
	}
	else
		ModifyStyleEx(0, WS_EX_APPWINDOW);

	m_hHandCur = ::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND));

	rsl[0] = &m_rpre;
	rsl[1] = &m_r1;
	rsl[2] = &m_r2;
	rsl[3] = &m_r3;
	rsl[4] = &m_r4;
	rsl[5] = &m_r5;
	rsl[6] = &m_r6;
	rsl[7] = &m_r7;
	rsl[8] = &m_r8;
	rsl[9] = &m_r9;
	rsl[10] = &m_r10;
	rsl[11] = &m_r11;
	rsl[12] = &m_r12;
	rsl[13] = &m_r13;
	rsl[14] = &m_r14;
	rsl[15] = &m_r15;
	rsl[16] = &m_r16;
	rsl[17] = &m_r17;
	rsl[18] = &m_r18;

	lsl[0] = &m_lpre;
	lsl[1] = &m_l1;
	lsl[2] = &m_l2;
	lsl[3] = &m_l3;
	lsl[4] = &m_l4;
	lsl[5] = &m_l5;
	lsl[6] = &m_l6;
	lsl[7] = &m_l7;
	lsl[8] = &m_l8;
	lsl[9] = &m_l9;
	lsl[10] = &m_l10;
	lsl[11] = &m_l11;
	lsl[12] = &m_l12;
	lsl[13] = &m_l13;
	lsl[14] = &m_l14;
	lsl[15] = &m_l15;
	lsl[16] = &m_l16;
	lsl[17] = &m_l17;
	lsl[18] = &m_l18;

	for (i = 0; i < 19; i++)
	{
		CString lFirstMessage;
		CString rFirstMessage;
		CString lSecondMessage;
		CString rSecondMessage;
		if (i == 0)
		{
			lFirstMessage = m_Helper.MyLoadString(IDS_LPREAMPCUT);
			lSecondMessage = m_Helper.MyLoadString(IDS_LPREAMPDB);
			rFirstMessage = m_Helper.MyLoadString(IDS_RPREAMPCUT);
			rSecondMessage = m_Helper.MyLoadString(IDS_RPREAMPDB);
		}
		else
		{
			lFirstMessage = m_Helper.MyLoadString(IDS_LHZCUT);
			lSecondMessage = m_Helper.MyLoadString(IDS_LHZDB);
			rFirstMessage = m_Helper.MyLoadString(IDS_RHZCUT);
			rSecondMessage = m_Helper.MyLoadString(IDS_RHZDB);
		}

		InitCursor(lsl[i]);
		lsl[i]->SetMessage(freqs[i], lFirstMessage, lSecondMessage);
		lsl[i]->SetPos(lslpos[i]);
		last_lslpos[i] = lslpos[i];

		InitCursor(rsl[i]);
		rsl[i]->SetMessage(freqs[i], rFirstMessage, rSecondMessage);
		rsl[i]->SetPos(rslpos[i]);
		last_rslpos[i] = rslpos[i];
	}

	for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
	{
		int indx = m_list_param.AddString(e->getString());
		m_list_param.SetItemDataPtr(indx, e);
	}

	last_param_index = -1;

	set_gui_from_paramlistelm(-1);

	lastparamroot.copy(paramroot);

	m_ed_target.SetWindowText(_T(""));

	m_ch_enable2.SetCheck(m_ch_enable);

	return TRUE;
}

void CEqualizerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if (pMainFrame->EQOnTop == 1)
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_UNCHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(0, WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->EQOnTop = 0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW, 0);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->EQOnTop = 1;
		}
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

void CEqualizerDlg::InitCursor(CBitSlider* slider)
{
	slider->SetFlipCursor(m_hHandCur);
	slider->BuildThumbItem(IDB_VERTICAL_THUMB, 12, 6);
	slider->BuildBackItem(IDB_VERTICAL_NORMAL, IDB_VERTICAL_ACTIVE);
	slider->SetLeftOffset(3);
	slider->SetTopOffset(3);
	slider->SetRangeMin(0);
	slider->SetRangeMax(96);
	slider->SetLineSize(0);
}

void CEqualizerDlg::OnChEnable()
{
	extern int enable;
	enable = m_ch_enable2.GetCheck();
}

void CEqualizerDlg::OnChLock()
{
	locklr = m_ch_lock2.GetCheck();
}

void CEqualizerDlg::OnButUp()
{
	int i;

	for (i = 1; i < 19; i++)
		if (lslpos[i] == 0 || rslpos[i] == 0)
			return;

	for (i = 1; i < 19; i++)
	{
		lslpos[i]--;
		rslpos[i]--;
		lsl[i]->SetPos(lslpos[i]);
		rsl[i]->SetPos(rslpos[i]);
	}

	not_applied = 1;
}

void CEqualizerDlg::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->EqualizerX = rect.left;
	pMainFrame->EqualizerY = rect.top;

	DestroyWindow();
}

void CEqualizerDlg::OnClose()
{
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnButDown()
{
	int i;

	for (i = 1; i < 19; i++)
		if (lslpos[i] == 96 || rslpos[i] == 96)
			return;

	for (i = 1; i < 19; i++)
	{
		lslpos[i]++;
		rslpos[i]++;
		lsl[i]->SetPos(lslpos[i]);
		rsl[i]->SetPos(rslpos[i]);
	}

	not_applied = 1;
}


void CEqualizerDlg::OnButApply()
{
	if (not_applied)
	{
		not_applied = 0;
		setBandsFromSlpos();
	}
}

void CEqualizerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	int i;

	for (i = 0; i < 19; i++)
	{
		lslpos[i] = last_lslpos[i];
		rslpos[i] = last_rslpos[i];
	}

	paramroot.copy(lastparamroot);

	setBandsFromSlpos();
}

void CEqualizerDlg::OnButPnew()
{
	paramlistelm* e = paramroot.newelm();
	int indx = m_list_param.AddString(e->getString());
	m_list_param.SetItemDataPtr(indx, e);

	last_param_index = indx;

	set_gui_from_paramlistelm(indx);
	m_list_param.SetCurSel(indx);
	not_applied = 1;
}

void CEqualizerDlg::OnButPdel()
{
	int indx = m_list_param.GetCurSel();
	if (indx == LB_ERR)
		return;
	paramlistelm* e = (paramlistelm*)m_list_param.GetItemDataPtr(indx);
	m_list_param.DeleteString(indx);
	paramroot.delelm(e);

	last_param_index = -1;
	set_gui_from_paramlistelm(-1);
	not_applied = 1;
}

void CEqualizerDlg::display(CString mes)
{
	m_ed_target.SetWindowText(mes);
}

void CEqualizerDlg::OnChDither()
{
	extern int dither;
	dither = m_ch_dither2.GetCheck();
}

void CEqualizerDlg::OnSelchangeListParam()
{
	if (last_param_index != -1)
		set_paramlistelm_from_gui(last_param_index);

	last_param_index = m_list_param.GetCurSel();
	if (last_param_index == LB_ERR)
		last_param_index = -1;

	set_gui_from_paramlistelm(last_param_index);
}

void CEqualizerDlg::OnKillfocusEdPlow()
{
	set_paramlistelm_from_gui(last_param_index);
}

void CEqualizerDlg::OnKillfocusEdPup()
{
	set_paramlistelm_from_gui(last_param_index);
}

void CEqualizerDlg::OnKillfocusEdGain()
{
	set_paramlistelm_from_gui(last_param_index);
}

void CEqualizerDlg::OnChPleft()
{
	set_paramlistelm_from_gui(last_param_index);
}

void CEqualizerDlg::OnChPright()
{
	set_paramlistelm_from_gui(last_param_index);
}

void CEqualizerDlg::OnBnClickedCancel()
{
	CDialog::OnCancel();
	SaveWindowPosAndDestroy();
}
