#ifndef CONFIG_DIALOG_H
#define CONFIG_DIALOG_H

#include "Tools/MenuXP.h"
#include "Tools/ButtonXP.h"
#include "Tools/ComboboxXP.h"
#include "Tools/BitSlider.h"

void load_from(CStringArray *listString);
void load_fromFilename(CString filename);

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg dialog

class CEqualizerDlg : public CDialog
{
public:
	void display(CString mes);
	CEqualizerDlg();
	~CEqualizerDlg();
	CEqualizerDlg* getInstance();

	void set_paramlistelm_from_gui(int);
	void set_gui_from_paramlistelm(int);
	void sort_param(void);
	afx_msg void OnBnClickedCancel();
	void SaveWindowPosAndDestroy();
	void OnClose();

	enum { IDD = IDD_EQUALIZER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnButLoad();
	afx_msg void OnButOk();
	afx_msg void OnButSave();
	virtual BOOL OnInitDialog();
	afx_msg void OnChEnable();
	afx_msg void OnChLock();
	afx_msg void OnButUp();
	afx_msg void OnButDown();
	afx_msg void OnButApply();
	afx_msg void OnDestroy();
	afx_msg void OnButPnew();
	afx_msg void OnButPdel();
	afx_msg void OnChDither();
	afx_msg void OnSelchangeListParam();
	afx_msg void OnKillfocusEdPlow();
	afx_msg void OnKillfocusEdPup();
	afx_msg void OnKillfocusEdGain();
	afx_msg void OnChPleft();
	afx_msg void OnChPright();
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
private:
	HCURSOR m_hHandCur;
	CEdit	m_ed_autoload;
	CButtonXP	m_but_pnew;
	CButtonXP	m_but_pdelete;
	CButtonXP	m_but_load;
	CButtonXP	m_but_save;
	CButtonXP	m_but_up;
	CButtonXP	m_but_down;
	CButtonXP	m_but_ok;
	CButtonXP	m_but_cancel;
	CButton	m_ch_pright2;
	CButton	m_ch_pleft2;
	CButton	m_ch_dither2;
	CListBox	m_list_param;
	CEdit	m_ed_pup;
	CEdit	m_ed_plow;
	CEdit	m_ed_gain;
	CButtonXP	m_but_apply;
	CButton	m_ch_lock2;
	CButton	m_ch_enable2;
	CEdit	m_ed_target;
	CBitSlider	m_rpre;
	CBitSlider	m_r9;
	CBitSlider	m_r8;
	CBitSlider	m_r7;
	CBitSlider	m_r6;
	CBitSlider	m_r5;
	CBitSlider	m_r4;
	CBitSlider	m_r3;
	CBitSlider	m_r2;
	CBitSlider	m_r18;
	CBitSlider	m_r17;
	CBitSlider	m_r16;
	CBitSlider	m_r15;
	CBitSlider	m_r14;
	CBitSlider	m_r13;
	CBitSlider	m_r12;
	CBitSlider	m_r11;
	CBitSlider	m_r10;
	CBitSlider	m_r1;
	CBitSlider	m_l9;
	CBitSlider	m_l8;
	CBitSlider	m_l7;
	CBitSlider	m_l6;
	CBitSlider	m_l5;
	CBitSlider	m_l4;
	CBitSlider	m_l3;
	CBitSlider	m_l2;
	CBitSlider	m_l18;
	CBitSlider	m_l17;
	CBitSlider	m_l16;
	CBitSlider	m_l15;
	CBitSlider	m_l14;
	CBitSlider	m_l13;
	CBitSlider	m_l12;
	CBitSlider	m_l11;
	CBitSlider	m_l10;
	CBitSlider	m_l1;
	CBitSlider	m_lpre;
	BOOL	m_ch_lock;
	BOOL	m_ch_enable;
	BOOL	m_ch_dither;
	BOOL	m_ch_pleft;
	BOOL	m_ch_pright;

	void InitCursor(CBitSlider* slider);
	DECLARE_MESSAGE_MAP()
	DECLARE_MENUXP()
};

#endif

extern CEqualizerDlg* EqualizerDlg;