/*****************************************************
** Module : CImageMap   							**
** Purpose : To locate sub images in skin template  **
**  												**
** Copyright James Spibey, 2000 (spib@bigfoot.com)  **
** Feel free to use and distribute. May not be sold ** 
** for profit.  									**
*****************************************************/

#include "stdafx.h"
#include "ImageMap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CImageMap::CImageMap()
{
	m_ImageMap[TITLEBAR_LEFT_CORNER].SetRect(0, 0, 25, 20);		//TitleBar Left Corner
	m_ImageMap[TITLEBAR_MIDDLE_LEFT].SetRect(26, 0, 51, 20);		//TitleBar Middle left
	m_ImageMap[TITLEBAR_MIDDLE].SetRect(52, 0, 77, 20);		//TitleBar Middle
	m_ImageMap[TITLEBAR_MIDDLE_RIGHT].SetRect(78, 0, 93, 20);		//TitleBar Middle right
	m_ImageMap[TITLEBAR_FILL].SetRect(104, 0, 129, 20);		//TitleBar Fill
	m_ImageMap[TITLEBAR_RIGHT_CORNER].SetRect(130, 0, 155, 20);		//TitleBar Right Corner
	m_ImageMap[INACTIVE_TITLEBAR_LEFT_CORNER].SetRect(0, 21, 25, 41);		//TitleBar Left Corner
	m_ImageMap[INACTIVE_TITLEBAR_MIDDLE_LEFT].SetRect(26, 21, 51, 41);		//TitleBar Middle left
	m_ImageMap[INACTIVE_TITLEBAR_MIDDLE].SetRect(52, 21, 77, 41);		//TitleBar Middle
	m_ImageMap[INACTIVE_TITLEBAR_MIDDLE_RIGHT].SetRect(78, 21, 93, 41);		//TitleBar Middle right
	m_ImageMap[INACTIVE_TITLEBAR_FILL].SetRect(104, 21, 129, 41);	//TitleBar Fill
	m_ImageMap[INACTIVE_TITLEBAR_RIGHT_CORNER].SetRect(130, 21, 155, 41);	//TitleBar Right Corner
	m_ImageMap[BOTTOM_LEFT].SetRect(0, 42, 125, 56);		//Bottom Left Corner
	m_ImageMap[BOTTOM_RIGHT].SetRect(0, 57, 125, 71);		//Bottom Right Corner
	m_ImageMap[BOTTOM_FILL].SetRect(127, 72, 152, 86);	//Bottom Filler
	m_ImageMap[LEFT_EDGE].SetRect(127, 42, 138, 71);	//Left Edge
	m_ImageMap[RIGHT_EDGE].SetRect(139, 42, 147, 71);	//Right Edge
	m_ImageMap[CLOSE_BUTTON].SetRect(52, 42, 61, 51);		//Close Button
	m_ImageMap[SCROLLBAR].SetRect(52, 53, 60, 71);		//Scrollbar
	m_ImageMap[SCROLLBAR_PRESSED].SetRect(61, 53, 69, 71);		//Scrollbar Pressed
	m_ImageMap[SHADE_LEFT_CORNER].SetRect(72, 42, 97, 56);		//Shade Left Corner
	m_ImageMap[SHADE_RIGHT_CORNER_ACTIVE].SetRect(99, 42, 149, 56);		//Shade Right Corner Active
	m_ImageMap[SHADE_MIDDLE].SetRect(72, 57, 97, 71);		//Shade Middle
	m_ImageMap[SHADE_RIGHT_CORNER_INACTIVE].SetRect(99, 57, 149, 71);		//Shade Right Corner InActive
	m_ImageMap[MAXIMIZE_BUTTON].SetRect(150, 42, 158, 51);	//Maximize Button
	m_ImageMap[LETTER_A].SetRect(1, 88, 7, 95);	//Letter A
	m_ImageMap[LETTER_B].SetRect(8, 88, 15, 95);	//Letter B
	m_ImageMap[LETTER_C].SetRect(16, 88, 23, 95);	//Letter C
	m_ImageMap[LETTER_D].SetRect(24, 88, 30, 95);	//Letter D
	m_ImageMap[LETTER_E].SetRect(31, 88, 37, 95);	//Letter E
	m_ImageMap[LETTER_F].SetRect(38, 88, 44, 95);	//Letter F
	m_ImageMap[LETTER_G].SetRect(45, 88, 52, 95);	//Letter G
	m_ImageMap[LETTER_H].SetRect(53, 88, 59, 95);	//Letter H
	m_ImageMap[LETTER_I].SetRect(60, 88, 64, 95);	//Letter I
	m_ImageMap[LETTER_J].SetRect(65, 88, 71, 95);	//Letter J
	m_ImageMap[LETTER_K].SetRect(72, 88, 79, 95);	//Letter K
	m_ImageMap[LETTER_L].SetRect(80, 88, 85, 95);	//Letter L
	m_ImageMap[LETTER_M].SetRect(86, 88, 94, 95);	//Letter M
	m_ImageMap[LETTER_N].SetRect(95, 88, 101, 95);	//Letter N
	m_ImageMap[LETTER_O].SetRect(102, 88, 108, 95);	//Letter O
	m_ImageMap[LETTER_P].SetRect(109, 88, 115, 95);	//Letter P
	m_ImageMap[LETTER_Q].SetRect(116, 88, 123, 95);	//Letter Q
	m_ImageMap[LETTER_R].SetRect(124, 88, 131, 95);	//Letter R
	m_ImageMap[LETTER_S].SetRect(132, 88, 138, 95);	//Letter S
	m_ImageMap[LETTER_T].SetRect(139, 88, 144, 95);	//Letter T
	m_ImageMap[LETTER_U].SetRect(145, 88, 151, 95);	//Letter U
	m_ImageMap[LETTER_V].SetRect(152, 88, 158, 95);	//Letter V
	m_ImageMap[LETTER_W].SetRect(159, 88, 167, 95);	//Letter W
	m_ImageMap[LETTER_X].SetRect(168, 88, 175, 95);	//Letter X
	m_ImageMap[LETTER_Y].SetRect(176, 88, 182, 95);	//Letter Y
	m_ImageMap[LETTER_Z].SetRect(183, 88, 188, 95);	//Letter Z
	m_ImageMap[INACTIVE_LETTER_A].SetRect(1, 96, 7, 103);	//Inactive letter A
	m_ImageMap[INACTIVE_LETTER_B].SetRect(8, 96, 15, 103);	//Inactive letter B
	m_ImageMap[INACTIVE_LETTER_C].SetRect(16, 96, 23, 103);	//Inactive letter C
	m_ImageMap[INACTIVE_LETTER_D].SetRect(24, 96, 30, 103);	//Inactive letter D
	m_ImageMap[INACTIVE_LETTER_E].SetRect(31, 96, 37, 103);	//Inactive letter E
	m_ImageMap[INACTIVE_LETTER_F].SetRect(38, 96, 44, 103);	//Inactive letter F
	m_ImageMap[INACTIVE_LETTER_G].SetRect(45, 96, 52, 103);	//Inactive letter G
	m_ImageMap[INACTIVE_LETTER_H].SetRect(53, 96, 59, 103);	//Inactive letter H
	m_ImageMap[INACTIVE_LETTER_I].SetRect(60, 96, 64, 103);	//Inactive letter I
	m_ImageMap[INACTIVE_LETTER_J].SetRect(65, 96, 71, 103);	//Inactive letter J
	m_ImageMap[INACTIVE_LETTER_K].SetRect(72, 96, 79, 103);	//Inactive letter K
	m_ImageMap[INACTIVE_LETTER_L].SetRect(80, 96, 85, 103);	//Inactive letter L
	m_ImageMap[INACTIVE_LETTER_M].SetRect(86, 96, 94, 103);	//Inactive letter M
	m_ImageMap[INACTIVE_LETTER_N].SetRect(95, 96, 101, 103);	//Inactive letter N
	m_ImageMap[INACTIVE_LETTER_O].SetRect(102, 96, 108, 103);	//Inactive letter O
	m_ImageMap[INACTIVE_LETTER_P].SetRect(109, 96, 115, 103);	//Inactive letter P
	m_ImageMap[INACTIVE_LETTER_Q].SetRect(116, 96, 123, 103);	//Inactive letter Q
	m_ImageMap[INACTIVE_LETTER_R].SetRect(124, 96, 131, 103);	//Inactive letter R
	m_ImageMap[INACTIVE_LETTER_S].SetRect(132, 96, 138, 103);	//Inactive letter S
	m_ImageMap[INACTIVE_LETTER_T].SetRect(139, 96, 144, 103);	//Inactive letter T
	m_ImageMap[INACTIVE_LETTER_U].SetRect(145, 96, 151, 103);	//Inactive letter U
	m_ImageMap[INACTIVE_LETTER_V].SetRect(152, 96, 158, 103);	//Inactive letter V
	m_ImageMap[INACTIVE_LETTER_W].SetRect(159, 96, 167, 103);	//Inactive letter W
	m_ImageMap[INACTIVE_LETTER_X].SetRect(168, 96, 175, 103);	//Inactive letter X
	m_ImageMap[INACTIVE_LETTER_Y].SetRect(176, 96, 182, 103);	//Inactive letter Y
	m_ImageMap[INACTIVE_LETTER_Z].SetRect(183, 96, 188, 103);	//Inactive letter Z
}
CImageMap::~CImageMap()
{
}
