#ifndef MAINWND_H
#define MAINWND_H

#include "Tools/MenuXP.h"
#include "Tooltip/TrayIconPosition.h"
#include "Tooltip/PPTooltip.h"

#define WM_ICON_NOTIFY WM_USER+1
#define IDM_RECENT_FILES 1200
#define IDM_TRACKS 1240
#define IDM_DRIVES 1210
#define ID_POPUPMENU_PIC 999

#define LBUTTON_CLICK						2
#define RBUTTON_CLICK						3	
#define RBUTTON_UP							4
#define LBUTTON_UP							5
#define DELAY_FROM_EXP						6
#define REFRESH_WINDOW						7
#define AUTOMATION_START					8
#define DELAY_FROM_TOOLTIP					9
#define DELAY_FROM_BEBORE_RESTART_TOOLTIP  10
#define WM_DELAY						   11
#define KILL_SETTINGS_DIALOG			   12
/////////////////////////////////////////////////////////////////////////////
// CMainWnd frame


struct OpenPlayListStruct
{
	CString fname;
	bool RandomFirst;
	bool Add;
	bool ForceStart;
};

typedef struct _SkinStruct
{
	HICON PlayIcon;
	HICON PauseIcon;
	HICON StopIcon;
	HICON PrevIcon;
	HICON NextIcon;
	HBITMAP Buttons;
	HBITMAP ButtonsDn;
	CString PlayIconName;
	CString PauseIconName;
	CString StopIconName;
	CString PrevIconName;
	CString NextIconName;
	CString ButtonsName;
	CString ButtonsDnName;
	COLORREF startColor;
	COLORREF endColor;
	COLORREF m_border_color;
	COLORREF m_end_bk;
	COLORREF m_mid_bk;
	COLORREF m_start_bk;
	CString toolTipText;
	int m_theme;
	int m_effect_bk;
	BYTE m_granularity;
	BOOL m_border;
	int m_custom_border;
	BYTE m_border_width;
	BYTE m_border_height;
	BYTE m_transparency;
} SkinStruct;

class CMainWnd : public CFrameWnd
{
	// Construction
public:
	CMainWnd();
	~CMainWnd();

	HHOOK hHook;

	CMenu* pPopup, mainMenu;
	CString sortTemplate;
	bool showGradient;
	bool showGradientSel;
	bool showToolTip;
	bool autoUpdate;
	bool displayConsole;
	bool needToRestart;
	UINT m_show_time;
	UINT m_hide_time;
	UINT m_fade_in;
	UINT m_fade_out;
	DWORD m_animation;

	CString exename;

	NOTIFYICONDATA nid;
	bool AutOnStart;
	bool AutSaveset;
	CString W2Ffile;
	CString W2Fplay;
	CString W2Fpause;
	CString W2Fstop;
	CString W2Fexit;
	BOOL W2Foem;
	BOOL W2Fdel;
	BOOL W2Fenabled;
	BOOL W2FFtp;
	CString W2FSite;
	CString W2FUser;
	CString W2FPassword;
	bool Created;
	bool SMAlbum;
	bool SMTracks;
	bool SMPrevNext;
	CStringArray AutDirs;
	bool AutSort;
	bool AutRemove;
	bool AutRemovedup;
	bool AutRescan;
	int AutPeriod;
	bool AutEvery;
	CStringArray presets;
	bool AlbumStop;
	bool ShowTTT;
	bool DockSD;
	bool WAEmu;
	UINT FirstInMyRandom;
	CString Language;
	CString RNTemplate;
	POINT CurMousePos;
	int TPC;
	int Clicks1;
	int Clicks2;
	int Clicks3;
	int Clicks4;
	int RClicks1;
	int RClicks2;
	int RClicks3;
	int RClicks4;
	bool lbd;
	bool rbd;
	bool IconShown;
	bool GraphicalButtons;
	int TrackDurI;
	int HLevel;
	int PressAndHold;
	bool TraySeeking;
	bool Notified;
	int ExtPlaylistFormat;
	bool SBDockB;
	bool SBDockR;
	int SBCaption;
	BOOL DoingVolSet;
	int ShowingMode;
	bool ShowGradientBar;
	int AutoVCheck;
	int CurrentVolume;
	int CurrentPanning;
	int ShowRemainingTime;
	int PlaylistOnTop;
	int EQOnTop;
	int InfoOnTop;
	int NoClicks;
	int rndlst[50000];
	int* rndpntr;
	int ShuffleMode;
	bool ShutdownAfterEnd;
	bool ExitAfterEnd;
	HICON StpIcon;
	HICON StpIconSm;
	bool AddFromExp;
	CString InitDir;
	int RandomFirst;
	int AutoPlay;
	UINT m_NPKey;
	UINT m_NPMod;
	UINT m_ForwKey;
	UINT m_ForwMod;
	UINT m_BackKey;
	UINT m_BackMod;
	UINT m_ExitKey;
	UINT m_ExitMod;
	UINT m_PlayKey;
	UINT m_PlayMod;
	UINT m_StopKey;
	UINT m_StopMod;
	UINT m_PrevKey;
	UINT m_PrevMod;
	UINT m_NextKey;
	UINT m_NextMod;
	UINT m_VUpKey;
	UINT m_VUpMod;
	UINT m_VDownKey;
	UINT m_VDownMod;
	UINT m_OpenKey1; 
	UINT m_OpenMod1; 
	UINT m_OpenKey2; 
	UINT m_OpenMod2;
	UINT m_OpenKey3; 
	UINT m_OpenMod3;
	UINT m_MinibarKey;
	UINT m_MinibarMod;
	UINT m_MP3InfoKey;
	UINT m_MP3InfoMod;
	UINT m_PlaylistKey;
	UINT m_PlaylistMod;
	UINT m_EqualizerKey;
	UINT m_EqualizerMod;
	UINT m_RepeatKey;
	UINT m_RepeatMod;
	UINT m_ShuffleKey;
	UINT m_ShuffleMod;
	UINT m_AlbummodeKey;
	UINT m_AlbummodeMod;
	UINT m_TrayIconKey;
	UINT m_TrayIconMod;
	UINT m_MenuKey;
	UINT m_MenuMod;
	UINT m_TracksKey;
	UINT m_TracksMod;
	UINT m_AlbumKey;
	UINT m_AlbumMod;
	UINT m_AutomationKey;
	UINT m_AutomationMod;
	int GapBtwTracks;
	CString Recent[10];
	HBITMAP hMenuBitmap;
	CStringArray CurrentSkin;
	int CurrentSkinSel;
	SkinStruct mySkin;
	BOOL changeSkinOnEachTrack;
	BOOL randomSkin;
	bool opening;
	int lbs;
	int rbs;
	int SeekBarX;
	int SeekBarY;
	int SeekBarW;
	int EqualizerX;
	int EqualizerY;
	int PlaylistX;
	int PlaylistY;
	int PlaylistW;
	int PlaylistH;
	int VideoX;
	int VideoY;
	int VideoW;
	int VideoH;
	BOOL FullScreen;
	int m_Repeat;
	int m_RepeatTrack;
	int m_udpreamp1;
	int m_udpreamp2;
	int m_udpreamp3;
	CStringArray m_EQ;
	BOOL XPLookNFeel;
	bool startToolTip;
	bool firstPass;
	CTrayIconPosition m_tray_pos;
	CPPToolTip m_traytip;
	OpenPlayListStruct myPlayListStruct;
	bool m_activateWindowsMessenger;
	CString m_wmTitle;
	CString m_prevTitle;
	int m_wmIcon;
	int m_wmSpeed;
	int m_scrollMode;
	int m_incCounter;

	void AddRecent(CString fdn);
	void BuildAlbumMenu(CMenu* m);
	void BuildMenu(CMenu* m);
	int BuildMenuLevel(CMenu* m, int l, int start, int finish, CString cur);
	void BuildPrevNextMenu(CMenu* m);
	void ClickAction(int action);
	void DisplayTooltip();
	void DrawFragment(DRAWITEMSTRUCT* psI, int frg);
	bool ExtractLevel(CString s, int l, CString* r);
	CString ExtractLevelPath(CString s, int l);
	bool FileExists(CString fname);
	void FindMP3Files(CString path, bool nodups = false);
	void Finish();
	void GetAlbumRange(int* b, int* e, bool force = false, int track = -1);
	int GetMaxLevel(UINT start, UINT finish);
	void GoNext();
	void GetPosForMenu(LPPOINT point);
	int GetStartLevel(UINT start, UINT finish);
	void HideTooltip();
	LRESULT IconNotify(WPARAM wParam, LPARAM lParam);
	void LoadSkin(CString fname, SkinStruct* loadSkin);
	void LoadSkinOld(CString fname, SkinStruct* loadSkin);
	void LoadSkinNew(CString fname, SkinStruct* loadSkin);
	void UseSkin(SkinStruct* useSkin);
	void LoadThePlaylist(bool ForceStart);
	UINT MyRandom(bool forw, bool init = false);
	void OpenFile(CString fname, bool Add = false, bool ForceStart = false);
	void OpenFolder(CString theDir, bool RandomFirst = false, bool Add = false, bool ForceStart = false);
	void OpenFolderEngine(CString theDir, bool RandomFirst = false, bool Add = false, bool ForceStart = false);
	void OpenPlaylist(CString fname, bool RandomFirst = false, bool Add = false, bool ForceStart = false);
	void OpenPlaylistEngine(CString fname, bool RandomFirst = false, bool Add = false, bool ForceStart = false);
	void OpenRecent(int num);
	void OpenUrl(CString m_URL, bool Add = false);
	void PerformW2File(bool ex);
	void RegHotKeys();
	CString ReplaceAmpersand(CString s);
	void SaveSettings();
	void SaveThePlaylist();
	void SendMSNMessage(bool enable, CString category, CString message);
	void ShowPopup(int MenuType = 0);
	void ShowTracksMenu(int MenuType = 0, bool CurAlbOnly = false);
	void Start();
	void Start2();
	bool sup(CString n1, CString n2);
	bool TryToEnd();
	void UnregHotKeys();
	void UpdMBTR(bool updtray = true);
	void PreOpenOperation(bool Add);
	void PostOpenOperation(UINT PLLPrev, bool RandomFirst, bool Add, bool ForceStart);

	afx_msg void OnPopupMenuExit();
	afx_msg void OnPopupMenuNext();
	afx_msg void OnPopupMenuOpenFile();
	afx_msg void OnPopupMenuAddFile();
	afx_msg void OnPopupMenuOpenUrl();
	afx_msg void OnPopupMenuPause();
	afx_msg void OnPopupMenuPlay();
	afx_msg void OnPopupMenuPrevious();
	afx_msg void OnPopupMenuStop();

	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnInitMenuPopup(CMenu* menu, UINT number, BOOL booleen);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu);

	//Niveau du menu affich
protected:
	DECLARE_DYNCREATE(CMainWnd)

	// Overrides
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	// Implementation
protected:
	afx_msg void OnAutomationPerformNow();
	afx_msg void OnAutomationSetup();
	afx_msg void OnClose();
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDrivesMenu(UINT nID);
	afx_msg void OnEndSession(BOOL bEnding);
	afx_msg void OnPopupMenuAbout();
	afx_msg void OnPopupMenuArtistTitle();
	afx_msg void OnPopupMenuDockToActiveWindow();
	afx_msg void OnPopupMenuElapsedTime();
	afx_msg void OnPopupMenuEqualizer();
	afx_msg void OnPopupMenuFileInfo();
	afx_msg void OnPopupMenuFilename();
	afx_msg void OnPopupMenuOpenFolder();
	afx_msg void OnPopupMenuAddFolder();
	afx_msg void OnPopupMenuOpenRecent(UINT nID);
	afx_msg void OnPopupMenuPlaylistEditor();
	afx_msg void OnPopupMenuRemainingTime();
	afx_msg void OnPopupMenuSettingsAdvanced();
	afx_msg void OnPopupMenuSettingsAfterEndOfThePlaybackExitStp();
	afx_msg void OnPopupMenuSettingsAfterEndOfThePlaybackTurnOffTheComputer();
	afx_msg void OnPopupMenuSettingsRandomlySelectFirstTrack();
	afx_msg void OnPopupMenuSettingsRepeat();
	afx_msg void OnPopupMenuSettingsRepeatTrack();
	afx_msg void OnPopupMenuSettingsShuffleMode();
	afx_msg void OnPopupMenuSettingsSortByName();
	afx_msg void OnPopupMenuSettingsSortByFilename();
	afx_msg void OnPopupMenuSettingsSortByTemplate();
	afx_msg void OnPopupMenuSettingsStopAfterEachAlbum();
	afx_msg void OnPopupMenuShowTotalTrackTime();
	afx_msg void OnPopupMenuSeek();
	afx_msg void OnPopupMenuVideo();
	afx_msg void OnPopupMenuTitle();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTrackMenu(UINT nID);
	afx_msg void OnUpdatePopupMenuArtistTitle(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuDockToActiveWindow(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuElapsedTime(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuEqualizer(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuFileInfo(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuFilename(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuPlaylistEditor(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuRemainingTime(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSeek(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuVideo(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsAfterEndOfThePlaybackExitStp(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsAfterEndOfThePlaybackTurnOffComputer(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsRandomlySelectFirstTrack(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsRepeat(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsRepeatTrack(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsShuffleMode(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuSettingsStopAfterEachAlbum(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuShowTotalTrackTime(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePopupMenuTitle(CCmdUI* pCmdUI);
	LRESULT OnPostPlayerOver(UINT nFlags, LPARAM lp);
	static LRESULT CALLBACK HookCallWndProc(int nCode, WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#endif

extern CMainWnd* pMainFrame;
