#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "PlaylistManager.h"
#include "SysTrayPlay.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "PlaylistDlg.h"
#include "In/MultiDllInput.h"
#include "Out/MultiDllOutput.h"
#include "WAEmuWnd.h"
#include "QArray.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE hTagsThread = NULL;
HANDLE hAutomationThread = NULL;
extern CStringArray genres;

DWORD q;

BOOL operator ==(CachedTag& first, CachedTag& second)
{
	CString strFirst = first.GetSortPath();
	CString strSecond = second.GetSortPath();

	return (strFirst.CompareNoCase(strSecond) == 0);
}

BOOL operator >(CachedTag& first, CachedTag& second)
{
	CString strFirst = first.GetSortPath();
	CString strSecond = second.GetSortPath();

	CString firstPath = "";
	if (strFirst.ReverseFind('\\') != -1)
		firstPath = strFirst.Left(strFirst.ReverseFind('\\'));
	CString secondPath = "";
	if (strSecond.ReverseFind('\\') != -1)
		secondPath = strSecond.Left(strSecond.ReverseFind('\\'));
	CString firstFilename = strFirst.Right(strFirst.GetLength() - strFirst.ReverseFind('\\') - 1);
	CString secondFilename = strSecond.Right(strSecond.GetLength() - strSecond.ReverseFind('\\') - 1);

	if (firstPath.CompareNoCase(secondPath) != 0)
	{
		if (firstPath.CompareNoCase(secondPath) > 0)
		{
			if (firstPath.Find(secondPath) == 0)
				return FALSE;
			else
				return TRUE;
		}
		else
		{
			if (secondPath.Find(firstPath) == 0)
				return TRUE;
			else
				return FALSE;
		}
	}
	return (firstFilename.CompareNoCase(secondFilename) > 0);
}

BOOL operator <(CachedTag& first, CachedTag& second)
{
	CString strFirst = first.GetSortPath();
	CString strSecond = second.GetSortPath();

	CString firstPath = "";
	if (strFirst.ReverseFind('\\') != -1)
		firstPath = strFirst.Left(strFirst.ReverseFind('\\'));
	CString secondPath = "";
	if (strSecond.ReverseFind('\\') != -1)
		secondPath = strSecond.Left(strSecond.ReverseFind('\\'));
	CString firstFilename = strFirst.Right(strFirst.GetLength() - strFirst.ReverseFind('\\') - 1);
	CString secondFilename = strSecond.Right(strSecond.GetLength() - strSecond.ReverseFind('\\') - 1);

	if (firstPath.CompareNoCase(secondPath) != 0)
	{
		if (firstPath.CompareNoCase(secondPath) < 0)
		{
			if (secondPath.Find(firstPath) == 0)
				return FALSE;
			else
				return TRUE;
		}
		else
		{
			if (firstPath.Find(secondPath) == 0)
				return TRUE;
			else
				return FALSE;
		}
	}
	return (firstFilename.CompareNoCase(secondFilename) < 0);
}


CachedTag::CachedTag()
{
	sortPath = "";
	duration = 0;
	genre = 0;
	read = false;
	artist = "";
	album = "";
	comment = "";
	composer = "";
	playlist = "";
	title = "";
	year = "";
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
}

CachedTag::CachedTag(const CachedTag& copie)
{
	sortPath = copie.sortPath;
	read = copie.read;
	duration = copie.duration;
	genre = copie.genre;
	artist = copie.artist;
	album = copie.album;
	comment = copie.comment;
	composer = copie.composer;
	playlist = copie.playlist;
	title = copie.title;
	year = copie.year;
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
}

CachedTag::CachedTag(CString nPlaylist)
{
	sortPath = "";
	read = false;
	duration = 0;
	genre = 0;
	artist = "";
	album = "";
	comment = "";
	composer = "";
	playlist = nPlaylist;
	title = "";
	year = "";
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
}

CachedTag::~CachedTag()
{
}

void CachedTag::copy(CachedTag copie)
{
	sortPath = copie.sortPath;
	read = copie.read;
	duration = copie.duration;
	genre = copie.genre;
	artist = copie.artist;
	album = copie.album;
	comment = copie.comment;
	composer = copie.composer;
	playlist = copie.playlist;
	title = copie.title;
	year = copie.year;
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
}

CString CachedTag::GetAlbum()
{
	if (!read)
		ReadTag();
	return album;
}

CString CachedTag::GetArtist(bool fastDisplay)
{
	if (fastDisplay && !read)
		return "";
	if (!read)
		ReadTag();
	return artist;
}

CString CachedTag::GetComment()
{
	if (!read)
		ReadTag();
	return comment;
}

CString CachedTag::GetComposer()
{
	if (!read)
		ReadTag();
	return composer;
}

int CachedTag::GetGenreI()
{
	if (!read)
		ReadTag();
	return genre;
}


CString CachedTag::GetGenre()
{
	if (!read)
		ReadTag();
	return genres[GetGenreI()];
}

CString CachedTag::GetFilenameExt()
{
	CString filename = playlist;
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
	filename.Format(_T("%s%s"), fname, ext);
	if (_tcsstr(path, _T("://")) != NULL)
		filename.Format(_T("%s"), path);
	return filename;
}

CString CachedTag::GetDuration(bool fastDisplay)
{
	if (fastDisplay && !read && duration == 0)
		return "";
	if (!fastDisplay && !read)
		ReadTag();
	CString dur = "mm:ss";
	if (duration != 0)
		dur.Format(_T(" %02d:%02d"), (int)(duration / 60), duration % 60);
	else
		dur = "";
	return dur;
}

int CachedTag::GetDurationI()
{
	return duration;
}

CString CachedTag::GetPlaylist()
{
	return playlist;
}

bool CachedTag::GetRead()
{
	return read;
}

CString CachedTag::GetTag(int ShowingMode, bool fastDisplay)
{
	CString CurrentSong = "";

	if (ShowingMode == 2)
		CurrentSong = GetFilenameExt();
	else if (ShowingMode == 1)
	{
		if (GetArtist(fastDisplay).GetLength() == 0)
			CurrentSong = GetTitle(fastDisplay);
		else
		{
			CurrentSong.Format(_T("%s - %s"), GetArtist(fastDisplay), GetTitle(fastDisplay));
		}
	}
	else if (ShowingMode == 0)
	{
		TCHAR info[MAX_PATH];
		int length = 0;
		stdIn->GetFileInfo((TCHAR *)GetPlaylist().GetString(), info, &length);
		CurrentSong.Format(_T("%s"), info);
		CurrentSong = GetTitle(fastDisplay);
	}
	return CurrentSong;
}

CString CachedTag::GetTitle(bool fastDisplay)
{
	if (fastDisplay && !read && title == "")
		return GetFilename();
	if (!read && title == "")
		ReadTag();
	return title;
}

CString CachedTag::GetYear()
{
	if (!read)
		ReadTag();
	return year;
}

CString CachedTag::GetDrive()
{
	CString tmp;
	tmp.Format(_T("%s"), drive);
	return tmp;
}

CString CachedTag::GetDir()
{
	CString tmp = "";
	if (playlist.Find(_T("://")) == -1)
		tmp.Format(_T("%s"), dir);
	return tmp;
}

CString CachedTag::GetFilename()
{
	CString tmp;
	if (_tcsstr(playlist, _T("://")) != NULL)
		tmp.Format(_T("%s"), playlist);
	else
		tmp.Format(_T("%s"), fname);
	return tmp;
}

CString CachedTag::GetExt()
{
	CString tmp;
	tmp.Format(_T("%s"), ext);
	return tmp;
}

void CachedTag::ReadTag(bool forceRead)
{
	if (read && !forceRead)
		return;
	TCHAR filename[MAX_PATH];
	TCHAR meta[10];
	TCHAR ret[MAX_PATH];

	wcscpy(filename, (LPCTSTR)GetPlaylist());

	extendedFileInfoStructW eFIStruct;

	eFIStruct.filename = filename;
	eFIStruct.metadata = meta;
	eFIStruct.ret = ret;
	eFIStruct.ret[0] = 0;
	eFIStruct.retlen = 0;

	stdIn->GetFileInfo(filename, (TCHAR *)ret, (int*)&eFIStruct.retlen);
	SetTitle(eFIStruct.ret);
	SetDuration(eFIStruct.retlen / 1000);

	eFIStruct.retlen = MAX_PATH;

	wcscpy(meta, _T("length"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) > 0)
	{
		if (_wtoi(eFIStruct.ret) != 0)
		{
			SetDuration(_wtoi(eFIStruct.ret) / 1000);
		}
	}
	else
	{
		SetDuration(-1);
	}

	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("title"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) > 0)
	{
		SetTitle(eFIStruct.ret);
	}
	else
	{
		SetTitle(GetFilename());
	}
	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("artist"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) > 0)
	{
		SetArtist(eFIStruct.ret);
	}
	else
	{
		SetArtist("");
	}
	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("comment"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) >= 0)
	{
		SetComment(eFIStruct.ret);
	}
	else
	{
		SetComment("");
	}
	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("album"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) >= 0)
	{
		SetAlbum(eFIStruct.ret);
	}
	else
	{
		SetAlbum("");
	}
	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("year"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) >= 0)
	{
		SetYear(eFIStruct.ret);
	}
	else
	{
		SetYear("");
	}
	eFIStruct.retlen = MAX_PATH;
	wcscpy(meta, _T("genre"));
	wmemset(eFIStruct.ret, 0, MAX_PATH);
	if (stdIn->winampGetExtendedFileInfoW(eFIStruct) && wcslen(eFIStruct.ret) > 0)
	{
		SetGenreI(_wtoi(eFIStruct.ret));
	}
	read = true;
}
void CachedTag::SetAlbum(CString nAlbum)
{
	album = nAlbum;
}

void CachedTag::SetArtist(CString nArtist)
{
	artist = nArtist;
}

void CachedTag::SetComment(CString nComment)
{
	comment = nComment;
}

void CachedTag::SetComposer(CString nComposer)
{
	composer = nComposer;
}

void CachedTag::SetDuration(int nDuration)
{
	duration = nDuration;
}

void CachedTag::SetGenreI(int nGenre)
{
	genre = nGenre;
}

void CachedTag::SetPlaylist(CString nplaylist)
{
	playlist = nplaylist;
	TCHAR path[MAX_PATH];
	_tcscpy(path, (TCHAR *)playlist.GetString());
	_tsplitpath(path, drive, dir, fname, ext);
}

void CachedTag::SetTitle(CString nTitle)
{
	title = nTitle;
}

void CachedTag::SetYear(CString nYear)
{
	year = nYear;
}

void CachedTag::SetRead(bool nRead)
{
	read = nRead;
}

void CachedTag::SetSortPath(CString nSortPath)
{
	sortPath = nSortPath;
	sortPath.Replace(_T("%7"), GetFilenameExt());
	sortPath.Replace(_T("%8"), GetDrive());
	sortPath.Replace(_T("%9"), GetDir());
	if (sortPath.Find(_T("%")) != -1)
	{
		if (GetArtist() != "")
			sortPath.Replace(_T("%1"), GetArtist());
		else
			sortPath.Replace(_T("%1"), _T(""));
		if (GetTitle() != "")
			sortPath.Replace(_T("%2"), GetTitle());
		else
			sortPath.Replace(_T("%2"), _T(""));
		if (GetAlbum() != "")
			sortPath.Replace(_T("%3"), GetAlbum());
		else
			sortPath.Replace(_T("%3"), _T(""));
		if (GetYear() != "")
			sortPath.Replace(_T("%4"), GetYear());
		else
			sortPath.Replace(_T("%4"), _T(""));
		if (GetComment() != "")
			sortPath.Replace(_T("%5"), GetComment());
		else
			sortPath.Replace(_T("%5"), _T(""));
		if (GetDuration() != "")
			sortPath.Replace(_T("%6"), GetDuration());
		else
			sortPath.Replace(_T("%6"), _T(""));
	}
	sortPath.Replace(_T("\\\\"), _T("\\"));
}

CString CachedTag::GetSortPath()
{
	return sortPath;
}

PlaylistManager::PlaylistManager()
{
	InitializeCriticalSection(&m_cs);
	CachedTags = new CSortedArray<CachedTag, CachedTag&>();
	sortedCachedTags = new CSortedArray<CachedTag, CachedTag&>();
	Current = -1;
}

PlaylistManager::~PlaylistManager()
{
	CachedTags->RemoveAll();
	delete CachedTags;
	delete sortedCachedTags;
}

void PlaylistManager::Add(CString tag, int index)
{
	EnterCriticalSection(&m_cs);
	if (CachedTags->GetSize() == MAXFILE)
		return;
	try
	{
		CachedTag tmp(tag);
		if (index == -1)
			InsertAt(tmp, CachedTags->GetSize());
		else
		{
			CachedTags->GetAt(index).copy(tmp);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

void PlaylistManager::Add(CachedTag tag, int index)
{
	EnterCriticalSection(&m_cs);
	if (CachedTags->GetSize() == MAXFILE)
		return;
	try
	{
		if (index == -1)
			InsertAt(tag, CachedTags->GetSize());
		else
		{
			CachedTags->GetAt(index).copy(tag);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

void PlaylistManager::InsertAt(CachedTag tag, int index)
{
	EnterCriticalSection(&m_cs);
	if (CachedTags->GetSize() == MAXFILE)
		return;
	try
	{
		CachedTag tmp(tag);
		CachedTags->InsertAt(index, tmp);
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

CachedTag PlaylistManager::Get(int index)
{
	try
	{
		CachedTag tmp;
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index);
		}
		else
			return tmp;
	}
	catch (...)
	{
		CachedTag tmp;
		tmp.SetAlbum("");
		tmp.SetArtist("");
		tmp.SetComment("");
		tmp.SetComposer("");
		tmp.SetDuration(0);
		tmp.SetGenreI(0);
		tmp.SetPlaylist("");
		tmp.SetTitle("");
		tmp.SetYear("");
		return tmp;
	}
}

int PlaylistManager::GetIndex(CString filename)
{
	int posIndex;
	//TRACE(_T("GetIndex %s %d\n"), filename, GetSize());
	if (GetSize() == 0)
		return -1;
	for (posIndex = 0; posIndex < GetSize() && Get(posIndex).GetPlaylist().Compare(filename); posIndex++)
		;
	if (posIndex == GetSize())
		return -1;
	return posIndex;
}

CString PlaylistManager::GetAlbum(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetAlbum();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetArtist(int index, bool fastDisplay)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetArtist(fastDisplay);
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

void PlaylistManager::SetArtist(int index, CString artist)
{
	EnterCriticalSection(&m_cs);
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			CachedTags->GetAt(index).SetArtist(artist);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

CString PlaylistManager::GetComment(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetComment();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

void PlaylistManager::SetComment(int index, CString comment)
{
	EnterCriticalSection(&m_cs);
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			CachedTags->GetAt(index).SetComment(comment);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

CString PlaylistManager::GetComposer(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetComposer();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetDuration(int index, bool fastDisplay)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetDuration(fastDisplay);
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

void PlaylistManager::SetDuration(int index, int nDuration)
{
	EnterCriticalSection(&m_cs);
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			CachedTags->GetAt(index).SetDuration(nDuration);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}
int PlaylistManager::GetDurationI(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetDurationI();
		}
		else
			return 0;
	}
	catch (...)
	{
		return 0;
	}
}

CString PlaylistManager::GetFilenameExt(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetFilenameExt();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetGenre(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetGenre();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

int PlaylistManager::GetGenreI(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetGenreI();
		}
		else
			return 0;
	}
	catch (...)
	{
		return 0;
	}
}

CString PlaylistManager::GetPlaylist(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetPlaylist();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

bool PlaylistManager::GetRead(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetRead();
		}
		return false;
	}
	catch (...)
	{
		return false;
	}
}
int PlaylistManager::GetShowingMode()
{
	return ShowingMode;
}

CString PlaylistManager::GetTag(int index, bool fastDisplay)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetTag(ShowingMode, fastDisplay);
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetTitle(int index, bool fastDisplay)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetTitle(fastDisplay);
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

void PlaylistManager::SetTitle(int index, CString title)
{
	EnterCriticalSection(&m_cs);
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			CachedTags->GetAt(index).SetTitle(title);
		}
	}
	catch (...)
	{
	}
	LeaveCriticalSection(&m_cs);
}

CString PlaylistManager::GetYear(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetYear();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetDrive(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetDrive();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetDir(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetDir();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetFilename(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetFilename();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetExt(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetExt();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

CString PlaylistManager::GetSortPath(int index)
{
	try
	{
		if (index >= 0 && index < CachedTags->GetSize())
		{
			return CachedTags->GetAt(index).GetSortPath();
		}
		else
			return "";
	}
	catch (...)
	{
		return "";
	}
}

int PlaylistManager::GetSize()
{
	return CachedTags->GetSize();
}

void PlaylistManager::SetShowingMode(int nShowingMode)
{
	ShowingMode = nShowingMode;
}

bool PlaylistManager::StopReadAll()
{
	bool toret = (hTagsThread != NULL);
	if (toret)
	{
		::TerminateThread(hTagsThread, 0);
		TRACE(_T("Fin force ReadAllTagsThread"));
		LeaveCriticalSection(&m_PlaylistManager.m_cs);
		hTagsThread = NULL;
	}
	return toret;
}

bool PlaylistManager::StopPerformAutomation()
{
	bool toret = (hAutomationThread != NULL);
	if (toret)
	{
		::TerminateThread(hAutomationThread, 0);
		hAutomationThread = NULL;
	}
	return toret;
}

void ReadAllTagsThread()
{
	EnterCriticalSection(&m_PlaylistManager.m_cs);
	TRACE(_T("Dbut ReadAllTagsThread"));
	try
	{
		for (UINT i = 0; i < (UINT)m_PlaylistManager.GetSize(); i++)
		{
			m_PlaylistManager.ReadTagAT(i, true);
		}
		if (PlaylistDlg->IsWindowVisible())
		{
			PlaylistDlg->ShowTimes();
			PlaylistDlg->m_playlistat.RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
		}
	}
	catch (...)
	{
	}
	hTagsThread = NULL;
	TRACE(_T("Fin ReadAllTagsThread"));
	LeaveCriticalSection(&m_PlaylistManager.m_cs);
}

void PlaylistManager::ReadAllTags()
{
	if (hTagsThread == NULL)
	{
		hTagsThread = ::CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ReadAllTagsThread, NULL, 0, &q);
		::SetThreadPriority(hTagsThread, THREAD_PRIORITY_LOWEST);
	}
}
void PerformAutomationThread()
{
	TRACE(_T("PerformAutomationThread"));
	if (pMainFrame->AutRemove || pMainFrame->AutRemovedup || pMainFrame->AutRescan || pMainFrame->AutSort)
		m_PlaylistManager.StopReadAll();

	if (PlaylistDlg->IsWindowVisible())
	{
		PlaylistDlg->StopRemoveDuplicateEntries();
		PlaylistDlg->StopRemovene();
		PlaylistDlg->StopSort();
	}

	if (pMainFrame->AutRemove)
	{
		TRACE(_T("Remove not existant files"));
		PlaylistDlg->OnArrangeRemovene();
	}

	if (pMainFrame->AutSort)
	{
		TRACE(_T("Sort playlist"));
		PlaylistDlg->OnArrangeSortEngine(pMainFrame->sortTemplate);
	}

	if (pMainFrame->AutRemovedup)
	{
		TRACE(_T("Remove duplicate files"));
		PlaylistDlg->OnArrangeRemoveDuplicateEntries();
	}


	if (pMainFrame->AutRescan)
	{
		int PLLPrev = m_PlaylistManager.GetSize();
		for (int i = 0; i < pMainFrame->AutDirs.GetSize(); i++)
		{
			TRACE(_T("Rescan folders %s"), pMainFrame->AutDirs[i]);
			pMainFrame->FindMP3Files(pMainFrame->AutDirs[i], true);
		}

		m_PlaylistManager.QuickSort(TRUE);

		if ((pMainFrame->RandomFirst || pMainFrame->ShuffleMode) && PLLPrev == 0)
		{
			pMainFrame->FirstInMyRandom = pMainFrame->MyRandom(true, true);
			m_PlaylistManager.Current = pMainFrame->FirstInMyRandom;
		}
		else if (PLLPrev == 0)
		{
			m_PlaylistManager.Current = 0;
			pMainFrame->FirstInMyRandom = 0xFFFFFFFF;
		}

		if (PlaylistDlg->IsWindowVisible())
		{
			if (m_PlaylistManager.GetSize() != PLLPrev)
			{
				PlaylistDlg->FillPlaylist();
				PlaylistDlg->ShowFileName();
			}
			PlaylistDlg->m_playlistat.Invalidate();
		}

		if (PLLPrev == 0)
		{
			if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);

			if (m_PlaylistManager.Current < m_PlaylistManager.GetSize() - 1)
				m_PlaylistManager.Current++;
			else
			{
				m_PlaylistManager.Current = 0;
			}
			Sleep(77);
			m_PlaylistManager.ReadTagAT(m_PlaylistManager.Current);
			pMainFrame->UpdMBTR();
		}
	}
	hAutomationThread = NULL;
	TRACE(_T("End PerformAutomationThread"));
}

void PlaylistManager::PerformAutomation()
{
	TRACE(_T("PerformAutomation"));
	if (PlaylistDlg != NULL)
	{
		if (RemoveDuplicateEntriesThreadHan != NULL || RemoveneThreadHan != NULL || SortThreadHan != NULL)
			return;
	}

	if (hAutomationThread == NULL)
	{
		DWORD q;
		hAutomationThread = ::CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)PerformAutomationThread, NULL, 0, &q);
		::SetThreadPriority(hAutomationThread, THREAD_PRIORITY_LOWEST);
	}
}
void PlaylistManager::ReadTagAT(int index, bool forceRead)
{
	if (index >= 0 && index < CachedTags->GetSize())
	{
		CachedTags->GetAt(index).ReadTag(forceRead);
	}
}
void PlaylistManager::RemoveAt(int index)
{
	EnterCriticalSection(&m_cs);
	CachedTags->RemoveAt(index);
	LeaveCriticalSection(&m_cs);
}

void PlaylistManager::RemoveAll()
{
	EnterCriticalSection(&m_cs);
	StopReadAll();
	StopPerformAutomation();
	CachedTags->RemoveAll();
	LeaveCriticalSection(&m_cs);
}

void PlaylistManager::QuickSort(BOOLEAN asc)
{
	EnterCriticalSection(&m_cs);
	TRACE(_T("Dbut QuickSort"));
	CString playlist = "";
	if (m_PlaylistManager.Current >= 0 && m_PlaylistManager.Current < CachedTags->GetSize())
		playlist = GetPlaylist(m_PlaylistManager.Current);

	CSortedArray<CachedTag, CachedTag&>* tmp;

	for (int i = 0; i< CachedTags->GetSize(); i++)
	{
		CachedTag cachedTag(CachedTags->GetAt(i));
		cachedTag.SetSortPath(pMainFrame->sortTemplate);
		sortedCachedTags->OrderedInsert(cachedTag);
	}

	tmp = CachedTags;
	CachedTags = sortedCachedTags;
	sortedCachedTags = tmp;
	sortedCachedTags->RemoveAll();

	if (m_PlaylistManager.Current >= 0 && m_PlaylistManager.Current < CachedTags->GetSize())
		m_PlaylistManager.Current = GetIndex(playlist);
	TRACE(_T("Fin QuickSort"));
	LeaveCriticalSection(&m_cs);
}

int PlaylistManager::Compare(CachedTag& element1, CachedTag& element2)
{
	if (element1 > element2)
		return 1;
	if (element1 < element2)
		return -1;
	return 0;
}

void PlaylistManager::RemoveDuplicateEntries()
{
	EnterCriticalSection(&m_cs);
	TRACE(_T("Dbut RemoveDuplicateEntries"));
	int i = 0, j;
	//Tri d'abord
	QuickSort(TRUE);

	while (i < GetSize() - 1 && GetSize() > 0)
	{
		j = i + 1;
		while (GetPlaylist(i) == GetPlaylist(j))
		{
			RemoveAt(j);

			if (j < Current)
				Current--;
			else if (j == Current)
				Current = i;
		}
		i++;
	}
	TRACE(_T("Fin RemoveDuplicateEntries"));
	LeaveCriticalSection(&m_cs);
}

void PlaylistManager::Removene()
{
	EnterCriticalSection(&m_cs);
	TRACE(_T("Dbut Removene"));
	CString playlist = "";
	if (m_PlaylistManager.Current >= 0 && m_PlaylistManager.Current < CachedTags->GetSize())
		playlist = GetPlaylist(m_PlaylistManager.Current);
	int i = 0;
	while (i < GetSize() && GetSize() > 0)
	{
		if (!pMainFrame->FileExists(GetPlaylist(i)))
		{
			RemoveAt(i);
			if (i < Current)
				Current--;
		}
		else
			i++;
	}
	if (m_PlaylistManager.Current >= 0 && m_PlaylistManager.Current < CachedTags->GetSize())
		m_PlaylistManager.Current = GetIndex(playlist);
	TRACE(_T("Fin Removene"));
	LeaveCriticalSection(&m_cs);
}
