// SeekDialog.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "systrayplay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "SeekDialog.h"
#include "SettingsDialog.h"
#include "PlaylistManager.h"
#include "In/MultiDllInput.h"
#include "Out/MultiDllOutput.h"
#include "Tools/Draw.h"
#include "WAEmuWnd.h"

#include "Volume.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define POLICENAME _T("Arial")

CTranspBmp::CTranspBmp() : CStatic()
{
}

BEGIN_MESSAGE_MAP(CTranspBmp,CStatic)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void CTranspBmp::Create(WORD idb, int width, int height)
{
	w = width;h = height;
	bmp = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(idb), IMAGE_BITMAP, w, h, LR_DEFAULTCOLOR);
}

void CTranspBmp::Delete()
{
	DeleteObject(bmp);
}

void CTranspBmp::OnPaint()
{
	CPaintDC dc(this);
	COLORREF crGradientStart = pMainFrame->mySkin.startColor;
	COLORREF crGradientEnd = pMainFrame->mySkin.endColor;

	HDC hDC = CreateCompatibleDC(dc.m_hDC);

	CRect rect;
	GetClientRect(&rect);

	bmp = (HBITMAP)SelectObject(hDC, bmp);

	HDC hdc1 = CreateCompatibleDC(dc.m_hDC);
	HDC hdc2 = CreateCompatibleDC(dc.m_hDC);
	HDC hdc3 = CreateCompatibleDC(dc.m_hDC);
	HDC hdc4 = CreateCompatibleDC(dc.m_hDC);
	HDC hdc5 = CreateCompatibleDC(dc.m_hDC);

	HBITMAP bm1 = CreateBitmap(w, h, 1, 1, NULL);
	HBITMAP bm2 = CreateBitmap(w, h, 1, 1, NULL);
	HBITMAP bm3 = CreateCompatibleBitmap(hDC, w, h);
	HBITMAP bm4 = CreateCompatibleBitmap(hDC, w, h);
	HBITMAP bm5 = CreateCompatibleBitmap(hDC, w, h);

	SelectObject(hdc1, bm1);
	SelectObject(hdc2, bm2);
	SelectObject(hdc3, bm3);
	SelectObject(hdc4, bm4);
	SelectObject(hdc5, bm5);

	//Image Original
	COLORREF cColor = SetBkColor(hDC, RGB(255, 0, 255));
	BitBlt(hdc1, 0, 0, w, h, hDC, 0, 0, SRCCOPY);
	//Image invers
	BitBlt(hdc2, 0, 0, w, h, hdc1, 0, 0, NOTSRCCOPY);
	SetBkColor(hDC, cColor);
	if (!pMainFrame->XPLookNFeel)
		CDC::FromHandle(hdc5)->FillSolidRect(0, 0, w, h, GetSysColor(COLOR_BTNFACE));
	else if (inverse)
		SeekDialog->DrawGradient(CDC::FromHandle(hdc5), crGradientEnd, crGradientStart, CRect(0, 0, w, h));
	else
		SeekDialog->DrawGradient(CDC::FromHandle(hdc5), crGradientStart, crGradientEnd, CRect(0, 0, w, h));
	StretchBlt(hdc3, 0, 0, w, h, hdc5, 0, 0, w, h, SRCCOPY);
	StretchBlt(hdc4, 0, 0, w, h, hDC, 0, 0, w, h, SRCCOPY);
	//Fond Orignal
	//Et entre Image invers et fond
	BitBlt(hdc3, 0, 0, w, h, hdc1, 0, 0, SRCAND);      
	BitBlt(hdc4, 0, 0, w, h, hdc2, 0, 0, SRCAND);      
	//Ou entre les 2 images obtenu
	BitBlt(hdc4, 0, 0, w, h, hdc3, 0, 0, SRCPAINT);
	BitBlt(hdc5, 0, 0, w, h, hdc4, 0, 0, SRCCOPY);
	BitBlt(dc.m_hDC, 0, 0, w, h, hdc5, 0, 0, SRCCOPY);

	DeleteDC(hdc1);DeleteDC(hdc2);DeleteDC(hdc3);DeleteDC(hdc4);DeleteDC(hdc5);
	DeleteObject(bm1);DeleteObject(bm2);DeleteObject(bm3);DeleteObject(bm4);DeleteObject(bm5);

	bmp = (HBITMAP)SelectObject(hDC, bmp);

	DeleteDC(hDC);
}

CMyPrBar::CMyPrBar() : CProgressCtrl()
{
	MemDCCreated = false;
}

BEGIN_MESSAGE_MAP(CMyPrBar,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

void CMyPrBar::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (stdIn->isSeekable())
	{
		SeekDialog->ScrollFlag = true;
		CRect rect;
		GetClientRect(&rect);
		int newpos = (int)((float)(point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * (float)1000 / (float)(rect.Width()));
		int p = (int)((float)pMainFrame->TrackDurI*(float)newpos / (float)1000);
		if (p > pMainFrame->TrackDurI)
			p = pMainFrame->TrackDurI;
		if (pMainFrame->ShowTTT)
			SeekDialog->CurrentTime.Format(_T("%02d:%02d/%02d:%02d"), pMainFrame->ShowRemainingTime == 1 ? (int)((pMainFrame->TrackDurI - p) / 60) : p / 60, pMainFrame->ShowRemainingTime == 1 ? ((pMainFrame->TrackDurI - p) % 60) : p % 60, pMainFrame->TrackDurI / 60, pMainFrame->TrackDurI % 60);
		else
			SeekDialog->CurrentTime.Format(_T("%02d:%02d"), pMainFrame->ShowRemainingTime == 1 ? (int)((pMainFrame->TrackDurI - p) / 60) : p / 60, pMainFrame->ShowRemainingTime == 1 ? ((pMainFrame->TrackDurI - p) % 60) : p % 60);

		SetPos(newpos);

		SetCapture();
	}
}

void CMyPrBar::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (SeekDialog->ScrollFlag && stdIn->isSeekable())
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos = 0;
		if (point.x > 0)
		{
			if (point.x < rect.Width())
				newpos = (int)(point.x * 100 / rect.Width());
			else
				newpos = 100;
		}
		else
			newpos = 0;
		stdIn->SetOutputTime(newpos * stdIn->GetLength() / 100);
		pMainFrame->UpdMBTR();
		SeekDialog->ScrollFlag = false;
		::ReleaseCapture();
	}
}

void CMyPrBar::OnMouseMove(UINT nFlags, CPoint point)
{
	if ((nFlags & MK_LBUTTON) && SeekDialog->ScrollFlag && stdIn->isSeekable())
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos = (int)((float)(point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * (float)1000 / (float)(rect.Width()));
		int p = (int)((float)pMainFrame->TrackDurI*(float)newpos / (float)1000);
		if (p > pMainFrame->TrackDurI)
			p = pMainFrame->TrackDurI;
		if (pMainFrame->ShowTTT)
			SeekDialog->CurrentTime.Format(_T("%02d:%02d/%02d:%02d"), pMainFrame->ShowRemainingTime == 1 ? (int)((pMainFrame->TrackDurI - p) / 60) : p / 60, pMainFrame->ShowRemainingTime == 1 ? ((pMainFrame->TrackDurI - p) % 60) : p % 60, pMainFrame->TrackDurI / 60, pMainFrame->TrackDurI % 60);
		else
			SeekDialog->CurrentTime.Format(_T("%02d:%02d"), pMainFrame->ShowRemainingTime == 1 ? (int)((pMainFrame->TrackDurI - p) / 60) : p / 60, pMainFrame->ShowRemainingTime == 1 ? ((pMainFrame->TrackDurI - p) % 60) : p % 60);

		SetPos(newpos);
	}
}

void CMyPrBar::OnPaint()
{
	CPaintDC dc(this);
	COLORREF crGradientStart = pMainFrame->mySkin.startColor;
	COLORREF crGradientEnd = pMainFrame->mySkin.endColor;

	if (!pMainFrame->XPLookNFeel)
	{
		crGradientStart = ::GetSysColor(COLOR_MENUTEXT);
		crGradientEnd = ::GetSysColor(COLOR_BTNFACE);
	}

	if (!MemDCCreated)
	{
		CRect rect;
		GetClientRect(&rect);

		memDC.CreateCompatibleDC(&dc);
		memBitmap.CreateCompatibleBitmap(&dc, width = rect.Width(), height = rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated = true;
	}

	dc.FillSolidRect(0, 0, width, height, crGradientEnd);
	if (pMainFrame->XPLookNFeel)
		dc.FillSolidRect(0, 0, width * GetPos() / 1000, height, crGradientStart);
	else
		dc.FillSolidRect(0, 0, width * GetPos() / 1000, height, ::GetSysColor(COLOR_HIGHLIGHT));

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

	CRect r;

	LOGFONT lfont;
	memset(&lfont, 0, sizeof(LOGFONT));
	lfont.lfCharSet = DEFAULT_CHARSET;  			   // DWORD fdwCharSet
	_tcscpy(lfont.lfFaceName, POLICENAME);
	lfont.lfHeight = 68;
	//lfont.lfWeight = FW_BOLD;
	CFont MyFont;
	MyFont.CreatePointFontIndirect(&lfont);
	CFont* pFont = dc.SelectObject(&MyFont);
	int nBkMode = dc.SetBkMode(TRANSPARENT);
	COLORREF crText = dc.SetTextColor(crGradientStart);
	if (SeekDialog->CurrentSong != "")
	{
		r.left = width - (long)((pMainFrame->ShowTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
		r.top = 0;
		r.right = width - 2;
		r.bottom = height - 1;
		dc.DrawText(SeekDialog->CurrentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		r.left = 0;
		r.top = 0;
		r.right = width - (long)((pMainFrame->ShowTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
		r.bottom = height - 1;
		dc.DrawText(SeekDialog->CurrentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		if (pMainFrame->XPLookNFeel)
			dc.SetTextColor(crGradientEnd);
		else
			dc.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));

		r.left = width - (long)((pMainFrame->ShowTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
		r.top = 0;
		r.right = width - 2;
		r.bottom = height - 1;
		if (r.right > width * GetPos() / 1000)
			r.right = width * GetPos() / 1000 + 1;
		dc.DrawText(SeekDialog->CurrentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		r.left = 0;
		r.top = 0;
		r.right = width - (long)((pMainFrame->ShowTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
		r.bottom = height - 1;
		if (r.right > width * GetPos() / 1000)
			r.right = width * GetPos() / 1000 + 1;
		if (pMainFrame->XPLookNFeel)
			dc.SetBkColor(crGradientStart);
		dc.DrawText(SeekDialog->CurrentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
	}
	else
	{
		r.left = 0;
		r.top = 0;
		r.right = width - 1;
		r.bottom = height - 1;
		dc.DrawText(_T("STP MP3 player"), -1, &r, DT_CENTER | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
	}
	dc.SetTextColor(crText); 
	dc.SetBkMode(nBkMode);
	dc.SelectObject(pFont);

	CBrush br(crGradientEnd);
	dc.SelectObject(&br);
}

void CMyPrBar::OnRButtonUp(UINT nFlags, CPoint point)
{
	if (!SeekDialog->ScrollFlag)
		pMainFrame->ShowPopup(2);
}

CMyPrBarVol::CMyPrBarVol() : CProgressCtrl()
{
	MemDCCreated = false;
	ScrollFlag = false;
}

BEGIN_MESSAGE_MAP(CMyPrBarVol,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

void CMyPrBarVol::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rect;
	GetClientRect(&rect);
	pMainFrame->CurrentVolume = (int)((float)point.x * (float)255 / (float)(rect.Width()));
	SetPos(pMainFrame->CurrentVolume * 100 / 255);
	SetCapture();
	ScrollFlag = true;
	pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
	stdIn->SetVolume(pMainFrame->CurrentVolume);
}

void CMyPrBarVol::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (ScrollFlag)
	{
		ScrollFlag = false;
		::ReleaseCapture();
	}
}

void CMyPrBarVol::OnMouseMove(UINT nFlags, CPoint point)
{
	if (nFlags & MK_LBUTTON && ScrollFlag)
	{
		CRect rect;
		GetClientRect(&rect);
		pMainFrame->CurrentVolume = (int)((float)(point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * (float)255 / (float)(rect.Width()));
		SetPos(pMainFrame->CurrentVolume * 100 / 255);
		pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
		stdIn->SetVolume(pMainFrame->CurrentVolume);
	}
}

void CMyPrBarVol::OnPaint()
{
	COLORREF crGradientStart = pMainFrame->mySkin.startColor;
	COLORREF crGradientEnd = pMainFrame->mySkin.endColor;

	if (!pMainFrame->XPLookNFeel)
	{
		crGradientStart = ::GetSysColor(COLOR_MENUTEXT);
		crGradientEnd = ::GetSysColor(COLOR_BTNFACE);
	}
	CPaintDC dc(this);

	if (!MemDCCreated)
	{
		memDC.CreateCompatibleDC(&dc);
		CRect rect;
		GetClientRect(&rect);
		memBitmap.CreateCompatibleBitmap(&dc, width = rect.Width(), height = rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated = true;
	}

	dc.FillSolidRect(0, 0, width, height, crGradientEnd);
	if (pMainFrame->XPLookNFeel)
		dc.FillSolidRect(0, 0, width * GetPos() / 100, height, crGradientStart);
	else
		dc.FillSolidRect(0, 0, width * GetPos() / 100, height, ::GetSysColor(COLOR_HIGHLIGHT));

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

	CRect r;

	CString buf;
	buf.Format(_T("%3d%%"), GetPos());

	LOGFONT lfont;
	memset(&lfont, 0, sizeof(LOGFONT));
	lfont.lfCharSet = DEFAULT_CHARSET;  			   // DWORD fdwCharSet
	_tcscpy(lfont.lfFaceName, POLICENAME);
	lfont.lfHeight = 68;
	//    lfont.lfWeight = FW_BOLD;
	CFont MyFont;
	MyFont.CreatePointFontIndirect(&lfont);
	CFont* pFont = dc.SelectObject(&MyFont);
	int nBkMode = dc.SetBkMode(TRANSPARENT);
	COLORREF crText = dc.SetTextColor(crGradientStart);

	r.left = 0;
	r.top = 0;
	r.right = width - 2;
	r.bottom = height - 1;
	dc.DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

	if (pMainFrame->XPLookNFeel)
		dc.SetTextColor(crGradientEnd);
	else
		dc.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
	r.left = 0;
	r.top = 0;
	r.right = width - 2;
	r.bottom = height - 1;
	if (r.right > width * GetPos() / 100)
		r.right = width * GetPos() / 100 + 1;
	dc.DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

	dc.SetTextColor(crText); 
	dc.SetBkMode(nBkMode);
	dc.SelectObject(pFont);

	CBrush br(crGradientEnd);
	dc.SelectObject(&br);
}

void CMyPrBarVol::OnRButtonUp(UINT nFlags, CPoint point)
{
	pMainFrame->ShowPopup(2);
}


CSeekDialog::CSeekDialog() : CDialog(CSeekDialog::IDD)
{
	HDocked = VDocked = true;
	ScrollFlag = false;
	CanResize = false;
}
CSeekDialog::~CSeekDialog()
{
	SeekDialog = NULL;
}

BEGIN_MESSAGE_MAP(CSeekDialog, CDialog)
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_WM_MOVING()
	ON_WM_SIZING()
	ON_WM_DROPFILES()
	ON_WM_PAINT()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog message handlers

void CSeekDialog::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BAR, m_bar);
	DDX_Control(pDX, IDC_VOL, m_vol);
	DDX_Control(pDX, IDC_FORIEPT, m_ipe);
	DDX_Control(pDX, IDC_FORCONTROLS, m_mb);
}


CSeekDialog* CSeekDialog::getInstance()
{
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
		SeekDialog->SaveWindowPosAndDestroy();
	if (SeekDialog != NULL && SeekDialog->m_hWnd == NULL)
	{
		delete SeekDialog;
		SeekDialog = NULL;
	}
	if (SeekDialog == NULL)
	{
		SeekDialog = new CSeekDialog();
		SeekDialog->Create(CSeekDialog::IDD);
	}
	else
		SeekDialog->SetFocus();
	return SeekDialog;
}

void CSeekDialog::OnClose()
{
	SaveWindowPosAndDestroy();
	WAEmuWnd->ShowWindow(SW_HIDE);
	CDialog::OnClose();
}

void CSeekDialog::OnDestroy()
{
	m_ipe.Delete();
	m_mb.Delete();
	m_bar.DestroyWindow();
	m_vol.DestroyWindow();
	CDialog::OnDestroy();
}

void CSeekDialog::OnDropFiles(HDROP hDropInfo)
{
	TCHAR szFileName[_MAX_PATH];
	CString buf;
	UINT nFileCount = ::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);
	for (UINT i = 0; i < nFileCount; i++)
	{
		::DragQueryFile(hDropInfo, i, szFileName, _MAX_PATH);
		buf = szFileName;
		if (::GetFileAttributes(szFileName) & FILE_ATTRIBUTE_DIRECTORY)
		{
			if (buf[buf.GetLength() - 1] != '\\')
				buf += "\\";
			pMainFrame->FindMP3Files(buf);
		}
		else
		{
			if ((buf.Right(4)).CompareNoCase(_T(".M3U")) == 0 || (buf.Right(4)).CompareNoCase(_T(".PLS")) == 0)
				pMainFrame->OpenPlaylist(buf, false, false);
			else
				m_PlaylistManager.Add(buf);
		}
	}

	UINT PLLPrev = m_PlaylistManager.GetSize();
	if (m_PlaylistManager.GetSize() > 0)
	{
		if (PLLPrev == 0)
		{
			if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			if (pMainFrame->ShuffleMode)
			{
				pMainFrame->FirstInMyRandom = pMainFrame->MyRandom(true, true);
				m_PlaylistManager.Current = pMainFrame->FirstInMyRandom;
			}
			else
			{
				m_PlaylistManager.Current = 0;
				pMainFrame->FirstInMyRandom = 0xFFFFFFFF;
			}
			if (m_PlaylistManager.Current < m_PlaylistManager.GetSize() - 1)
				m_PlaylistManager.Current++;
			else
			{
				m_PlaylistManager.Current = 0;
			}
			if (pMainFrame->AutoPlay)
			{
				enqueueFileWithMetaStructW eFile;
				eFile.filename = (TCHAR *)m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current).GetString();
				::SendMessage(WAEmuWnd->m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);
			}
			else if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
		}
		pMainFrame->UpdMBTR();
		if (PlaylistDlg->IsWindowVisible())
		{
			PlaylistDlg->FillPlaylist();
			PlaylistDlg->ShowFileName();
		}
	}
	::DragFinish(hDropInfo);
}

BOOL CSeekDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetWindowText(_T("STP MiniBar"));
	ModifyStyleEx(0, WS_EX_ACCEPTFILES);
	ModifyStyleEx(0, WS_EX_TOOLWINDOW);
	SetTimer(1, 100, NULL);

	CRect rect, rect1, rect2;

	m_bar.GetWindowRect(&rect);
	ScreenToClient(&rect);
	l1 = rect.left;
	h1 = rect.Height();
	m_vol.GetWindowRect(&rect);
	w1 = rect.Width();
	m_ipe.GetWindowRect(&rect);
	w2 = rect.Width();

	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	GetWindowRect(&rect2);
	if (pMainFrame->SeekBarW == -1000)
		pMainFrame->SeekBarW = rect2.Width();
	if (pMainFrame->SeekBarX == -1000)
		pMainFrame->SeekBarX = (rect1.right - pMainFrame->SeekBarW) / 2;
	if (pMainFrame->SeekBarY == -1000)
		pMainFrame->SeekBarY = rect1.top;
	if (pMainFrame->SeekBarX < rect1.left)
		pMainFrame->SeekBarX = rect1.left;
	if (pMainFrame->SeekBarY < rect1.top)
		pMainFrame->SeekBarY = rect1.top;
	if (pMainFrame->SBDockR || pMainFrame->SeekBarX + pMainFrame->SeekBarW > rect1.right)
		pMainFrame->SeekBarX = rect1.right - pMainFrame->SeekBarW;
	if (pMainFrame->SBDockB || pMainFrame->SeekBarY + (rect2.bottom - rect2.top) > rect1.bottom)
		pMainFrame->SeekBarY = rect1.bottom - (rect2.bottom - rect2.top);

	SetWindowPos(&wndTopMost, pMainFrame->SeekBarX - 2, pMainFrame->SeekBarY - 2, pMainFrame->SeekBarW - 4, rect2.Height(), SWP_NOACTIVATE);

	if (pMainFrame->DockSD)
	{
		CRect rect1, rect2, rect3, rect4;
		GetWindowRect(&rect1);
		::GetWindowRect(::GetDesktopWindow(), &rect2);
		::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect3, 0);
		::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &rect4);
		SetWindowPos(NULL, (rect3.right - 400) / 2, (rect4.bottom < rect2.bottom) ? rect3.bottom - rect1.Height() : rect3.top, 400, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
	}

	GetClientRect(&rect);

	m_bar.SetWindowPos(NULL, 0, 0, rect.Width() - l1 - w1 - w2, h1, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_vol.SetWindowPos(NULL, rect.Width() - w1 - w2, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_ipe.SetWindowPos(NULL, rect.Width() - w2, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	m_ipe.Create(IDB_IPEN, 48, 15);
	m_mb.Create(IDB_MB, 60, 15);

	m_ipe.inverse = true;
	m_mb.inverse = false;
	m_vol.SetRange(0, 100);

	m_vol.SetPos(pMainFrame->CurrentVolume * 100 / 255);

	m_bar.SetRange(0, 1000);
	pMainFrame->UpdMBTR();

	//Calcul de la zone  effacer
	GetWindowRect(&rect);
	ScreenToClient(&rect);

	GetWindowRect(&rect2);
	ScreenToClient(&rect2);

	InflateRect(rect2, -2, -2);

	CRgn WindowRgn;
	CRgn PreserveRgn;

	rect2.bottom -= rect.top;
	rect2.top -= rect.top;
	rect2.right -= rect.left;
	rect2.left -= rect.left;
	rect.bottom -= rect.top;
	rect.top -= rect.top;
	rect.right -= rect.left;
	rect.left -= rect.left;

	WindowRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	PreserveRgn.CreateRectRgn(rect2.left, rect2.top, rect2.right, rect2.bottom);
	WindowRgn.CombineRgn(&WindowRgn, &PreserveRgn, RGN_AND);
	SetWindowRgn((HRGN__ *)WindowRgn.m_hObject, TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSeekDialog::OnLButtonDown(UINT nFlags, CPoint point)
{
	CPoint thePoint = point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if (thePoint.x >= rect.left + (rect.right - rect.left) * 5 / 6 && thePoint.x <= rect.right && thePoint.y >= rect.top + (rect.bottom - rect.top) / 3 && thePoint.y <= rect.bottom)
	{
		ReleaseCapture();
		SendMessage(0xA1, 2, 0);
	}
}

void CSeekDialog::OnLButtonUp(UINT nFlags, CPoint point)
{
	CPoint thePoint = point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if (thePoint.x >= rect.left && thePoint.x <= rect.right && thePoint.y >= rect.top && thePoint.y <= rect.bottom)
	{
		if (thePoint.x < rect.left + (rect.right - rect.left) * 1 / 6)
		{
			if (m_PlaylistManager.GetSize() > 0)
			{
				stdIn->InfoBox((TCHAR *)m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current).GetString(), WAEmuWnd->m_hWnd);
			}
		}
		else if (thePoint.x < rect.left + (rect.right - rect.left) * 2 / 6)
		{
			if (EqualizerDlg == NULL || EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
				EqualizerDlg = EqualizerDlg->getInstance();
			else if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
				EqualizerDlg->SaveWindowPosAndDestroy();
		}
		else if (thePoint.x < rect.left + (rect.right - rect.left) * 3 / 6)
		{
			if (!PlaylistDlg->IsWindowVisible())
				PlaylistDlg->ShowWindow(SW_SHOW);
			else
				PlaylistDlg->SaveWindowPosAndDestroy();
		}
		else if (thePoint.x < rect.left + (rect.right - rect.left) * 4 / 6)
			pMainFrame->ShowTracksMenu(2);
		else if (thePoint.x < rect.left + (rect.right - rect.left) * 5 / 6)
			pMainFrame->ShowTracksMenu(2, true);
		else
		{
			if (thePoint.y < rect.top + (rect.bottom - rect.top) / 3)
			{
				SaveWindowPosAndDestroy();
				WAEmuWnd->ShowWindow(SW_HIDE);
			}
		}
	}
	else
	{
		GetDlgItem(IDC_FORCONTROLS)->GetWindowRect(&rect);
		if (thePoint.x >= rect.left && thePoint.x <= rect.right && thePoint.y >= rect.top && thePoint.y <= rect.bottom)
		{
			if (thePoint.x < rect.left + (rect.right - rect.left) * 1 / 5)
				OnPlay();
			else if (thePoint.x < rect.left + (rect.right - rect.left) * 2 / 5)
				OnPause();
			else if (thePoint.x < rect.left + (rect.right - rect.left) * 3 / 5)
				OnStop();
			else if (thePoint.x < rect.left + (rect.right - rect.left) * 4 / 5)
				OnPrev();
			else
				OnNext();
		}
	}
}

void CSeekDialog::OnMoving(UINT nSide, LPRECT lpRect)
{
	//    TRACE(_T("OnMoving\n"));
	if (pMainFrame->DockSD)
		GetWindowRect(lpRect);
	CRect rect1;
	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	int newx = lpRect-> left, newy = lpRect->top;

	if (HDocked)
	{
		if (abs(lpRect->right - rect1.right) < 5)
		{
			if (abs(lpRect->right - rect1.right) > 1)
			{
				newx = lpRect->left;
				HDocked = false;
				//  			  TRACE(_T("UnDockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
			}
			else
				newx = rect1.right - (lpRect->right - lpRect->left);
		}
		if (abs(lpRect->left) < 5)
		{
			if (abs(lpRect->left - rect1.left) > 1)
			{
				newx = lpRect->left;
				HDocked = false;
				//  			  TRACE(_T("UnDockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
			}
			else
				newx = rect1.left - 2;
		}
	}
	else
	{
		if (abs(lpRect->right - rect1.right) < 5)
		{
			if (abs(lpRect->right - rect1.right) > 1)
			{
				HDocked = true;
				newx = rect1.right - (lpRect->right - lpRect->left);
				//  			  TRACE(_T("DockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
			}
			else
				newx = lpRect->left;
		}
		if (abs(lpRect->left - rect1.left) < 5)
		{
			if (abs(lpRect->left - rect1.left) > 1)
			{
				HDocked = true;
				newx = rect1.left;
				//  			  TRACE(_T("DockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
			}
			else
				newx = lpRect->left - 2;
		}
	}
	if (VDocked)
	{
		if (abs(lpRect->bottom - rect1.bottom) > 5)
		{
			if (abs(lpRect->bottom - rect1.bottom) > 1)
			{
				newy = lpRect->top;
				VDocked = false;
				//  			  TRACE(_T("UnDockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
			}
			else
				newy = rect1.top - 2;
		}
		if (abs(lpRect->top - rect1.top) > 5)
		{
			if (abs(lpRect->top - rect1.top) > 1)
			{
				newy = lpRect->top;
				VDocked = false;
				//  			  TRACE(_T("UnDockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
			}
			else
				newy = rect1.top - 2;
		}
	}
	else
	{
		if (abs(lpRect->bottom - rect1.bottom) < 5)
		{
			if (abs(lpRect->bottom - rect1.bottom) > 1)
			{
				VDocked = true;
				newy = rect1.top - 2;
				//  			  TRACE(_T("DockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
			}
			else
				newy = lpRect->top;
		}
		if (abs(lpRect->top - rect1.top) < 5)
		{
			if (abs(lpRect->top - rect1.top) > 1)
			{
				VDocked = true;
				newy = rect1.top - 2;
				//  			  TRACE(_T("DockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
			}
			else
				newy = lpRect->top;
		}
	}

	lpRect->right = newx + (lpRect->right - lpRect->left);
	lpRect->left = newx;
	lpRect->bottom = newy + (lpRect->bottom - lpRect->top);
	lpRect->top = newy;
}

void CSeekDialog::OnNext()
{
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);
}

void CSeekDialog::OnPaint()
{
	if (!pMainFrame->XPLookNFeel)
	{
		CDialog::OnPaint();
		return;
	}

	// Get a handle to the window's device context
	HDC hDC = ::GetWindowDC(m_hWnd);
	CPaintDC dc(this);

	CRect rect;

	HDC hdc1 = CreateCompatibleDC(hDC);
	GetWindowRect(&rect);

	HBITMAP bm1 = CreateCompatibleBitmap(hDC, rect.right - rect.left, rect.bottom - rect.top);
	SelectObject(hdc1, bm1);
	COLORREF crGradientStart = pMainFrame->mySkin.startColor;
	COLORREF crGradientEnd = pMainFrame->mySkin.endColor;

	rect.left = 3;
	rect.right = 63;
	rect.bottom = rect.Height() - 2;
	rect.top = 2;
	DrawGradient(CDC::FromHandle(hDC), crGradientStart, crGradientEnd, rect);
	rect.left = 2;
	rect.right = 3;
	DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientStart, rect);	
	BitBlt(hDC, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, hdc1, rect.left, rect.top, SRCCOPY);

	GetWindowRect(&rect);

	rect.right = rect.Width() / 2;
	rect.left = 63;
	rect.bottom = rect.Height() - 2;
	rect.top = 2;

	DrawGradient(CDC::FromHandle(hdc1), crGradientEnd, crGradientStart, rect);  
	BitBlt(hDC, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, hdc1, rect.left, rect.top, SRCCOPY);
	GetWindowRect(&rect);
	rect.right = rect.Width();
	rect.left = rect.right / 2;
	rect.right -= 48;
	rect.bottom = rect.Height() - 2;
	rect.top = 2;
	DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientEnd, rect);  
	BitBlt(hDC, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, hdc1, rect.left, rect.top, SRCCOPY);
	GetWindowRect(&rect);
	rect.left = rect.Width() - 2;
	rect.right = rect.left - 3;
	rect.left -= 48 + 3;
	rect.bottom = rect.Height() - 2;
	rect.top = 2;
	DrawGradient(CDC::FromHandle(hdc1), crGradientEnd, crGradientStart, rect);  
	BitBlt(hDC, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, hdc1, rect.left, rect.top, SRCCOPY);

	rect.left = rect.right;
	rect.right = rect.left + 3;
	DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientStart, rect);	
	BitBlt(hDC, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, hdc1, rect.left, rect.top, SRCCOPY);

	::ReleaseDC(m_hWnd, hDC);
	DeleteObject(hDC);

	m_mb.InvalidateRect(NULL);
	m_vol.InvalidateRect(NULL);
	m_ipe.InvalidateRect(NULL);
	m_bar.InvalidateRect(NULL);
}

void CSeekDialog::DrawGradient(CDC* pDC, COLORREF clrStart, COLORREF clrEnd, LPCRECT pRect)
{
	CBufferDC memDC(pDC->GetSafeHdc());

	int r = GetRValue(clrEnd) - GetRValue(clrStart);
	int g = GetGValue(clrEnd) - GetGValue(clrStart);
	int b = GetBValue(clrEnd) - GetBValue(clrStart);

	if (!r && !g && !b)
	{
		memDC.FillSolidRect(pRect, clrStart);
		return;
	}

	int nSteps = max(abs(r), max(abs(g), abs(b)));  

	float fStep = (float)(pRect->right - pRect->left) / (float)nSteps;
	float rStep = r / (float)nSteps;
	float gStep = g / (float)nSteps;
	float bStep = b / (float)nSteps;

	r = GetRValue(clrStart);
	g = GetGValue(clrStart);
	b = GetBValue(clrStart);

	CRect rcFill;
	int iOnBand = 0;
	for (iOnBand = 0; iOnBand < nSteps; iOnBand++)
	{
		rcFill.SetRect(pRect->left + (int)(iOnBand * fStep), 0, pRect->left + (int)((iOnBand + 1) * fStep), pRect->bottom);
		if (!rcFill.Width())
			continue;

		memDC.FillSolidRect(&rcFill, RGB(r + rStep * iOnBand, g + gStep * iOnBand, b + bStep * iOnBand));
	}
	if (rcFill.right < pRect->right)
	{
		rcFill.right = pRect->right;

		memDC.FillSolidRect(&rcFill, RGB(r + rStep * iOnBand, g + gStep * iOnBand, b + bStep * iOnBand));
	}
}

void CSeekDialog::OnPause()
{
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON3, 0);
}

void CSeekDialog::OnPlay()
{
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
}

void CSeekDialog::OnPrev()
{
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON1, 0);
}

void CSeekDialog::OnRButtonUp(UINT nFlags, CPoint point)
{
	pMainFrame->ShowPopup(2);
}

void CSeekDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);
	CanResize = bShow ? true : false;
}
void CSeekDialog::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	if (CanResize)
	{
		m_bar.memDC.DeleteDC();
		m_bar.memBitmap.DeleteObject();
		m_bar.MemDCCreated = false; 	

		CRect rect;
		GetClientRect(&rect);

		m_bar.SetWindowPos(NULL, 0, 0, rect.Width() - l1 - w1 - w2, h1, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_vol.SetWindowPos(NULL, rect.Width() - w1 - w2, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_ipe.SetWindowPos(NULL, rect.Width() - w2, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	}
}

void CSeekDialog::OnSizing(UINT nSide, LPRECT lpRect)
{
	TRACE(_T("OnSizing"));
	if (pMainFrame->DockSD)
		GetWindowRect(lpRect);
	CRect r, rect, rect2;
	GetWindowRect(&r);
	lpRect->top = r.top;
	lpRect->bottom = r.bottom;
	if (lpRect->right - lpRect->left < 200)
	{
		if (lpRect->left > r.left)
			lpRect->left = lpRect->right - 200;
		else
			lpRect->right = lpRect->left + 200;
	}
	//Calcul de la zone  effacer
	GetWindowRect(&rect);
	ScreenToClient(&rect);

	GetWindowRect(&rect2);
	ScreenToClient(&rect2);

	InflateRect(rect2, -2, -2);

	CRgn WindowRgn;
	CRgn PreserveRgn;

	rect2.bottom -= rect.top;
	rect2.top -= rect.top;
	rect2.right -= rect.left;
	rect2.left -= rect.left;
	rect.bottom -= rect.top;
	rect.top -= rect.top;
	rect.right -= rect.left;
	rect.left -= rect.left;

	WindowRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	PreserveRgn.CreateRectRgn(rect2.left, rect2.top, rect2.right, rect2.bottom);
	WindowRgn.CombineRgn(&WindowRgn, &PreserveRgn, RGN_AND);
	SetWindowRgn((HRGN__ *)WindowRgn.m_hObject, TRUE);
}

void CSeekDialog::OnStop()
{
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
}

void CSeekDialog::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 1)
	{
		if (pMainFrame->DockSD)
		{
			HWND w = ::GetForegroundWindow();
			if (w != NULL && w != pMainFrame->m_hWnd && !(::GetWindow(w, GW_OWNER) != NULL && ::GetWindow(w, GW_OWNER) == pMainFrame->m_hWnd) && !(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER) != NULL && ::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER) == pMainFrame->m_hWnd) && !(::GetWindow(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER), GW_OWNER) != NULL && ::GetWindow(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER), GW_OWNER) == pMainFrame->m_hWnd) && w != ::FindWindow(_T("Shell_TrayWnd"), NULL))
			{
				CRect rect, rect1, rect2;
				::GetWindowRect(w, &rect);
				::GetWindowRect(::GetDesktopWindow(), &rect2);
				GetWindowRect(&rect1);
				int sbcnt = ((::GetWindowLong(w, GWL_STYLE) & WS_SYSMENU) ? 1 : 0) + ((::GetWindowLong(w, GWL_STYLE) & WS_MINIMIZEBOX) ? 1 : 0) + ((::GetWindowLong(w, GWL_STYLE) & WS_MINIMIZEBOX) ? 1 : 0);
				if (rect == rect2 || (::IsWindowVisible(w) && (::GetWindowLong(w, GWL_STYLE) & WS_CAPTION) && !(::GetWindowLong(w, GWL_EXSTYLE) & WS_EX_TOOLWINDOW)) && !(::GetWindowLong(w, GWL_EXSTYLE) & WS_EX_TOPMOST) && rect.Width() - GetSystemMetrics(SM_CXSIZE) * ((float)sbcnt + .5) > 200)
				{
					long neww = 200;
					if (rect.Width() > 350)
						neww = 250;
					if (rect.Width() > 550)
						neww = 300;
					if (rect.Width() > 700)
						neww = 350;
					if (rect.Width() > 900)
						neww = 400;
					long newx = rect.right - neww - GetSystemMetrics(SM_CXSIZE) * (long)((float)sbcnt + 0.5) - 5;
					long newy = rect.top + ((::GetWindowLong(w, GWL_STYLE) & WS_THICKFRAME) ? 1 : 0) + 1;
					if (rect == rect2)
					{
						CRect rect3, rect4;
						::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect3, 0);
						::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &rect4);
						SetWindowPos(NULL, (rect3.right - 400) / 2, (rect4.bottom < rect2.bottom) ? rect3.bottom - rect1.Height() : rect3.top, 400, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
					}
					else
					{
						if (newx != rect1.left || newy != rect1.top)
							SetWindowPos(NULL, newx, newy, neww, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
					}
				}
			}
			else if (w == NULL)
			{
				CRect rect1, rect2, rect3, rect4;
				GetWindowRect(&rect1);
				::GetWindowRect(::GetDesktopWindow(), &rect2);
				::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect3, 0);
				::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &rect4);
				SetWindowPos(NULL, (rect3.right - 400) / 2, (rect4.bottom < rect2.bottom) ? rect3.bottom - rect1.Height() : rect3.top, 400, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
			}
		}
		return;
	}

	CDialog::OnTimer(nIDEvent);
}

void CSeekDialog::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->SeekBarX = rect.left + 2;
	pMainFrame->SeekBarY = rect.top + 2;
	pMainFrame->SeekBarW = rect.Width() + 4;
	CRect rect1;
	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	pMainFrame->SBDockR = (rect.right == rect1.right && !pMainFrame->DockSD);
	pMainFrame->SBDockB = (rect.bottom == rect1.bottom && !pMainFrame->DockSD);

	DestroyWindow();
}


