// SettingsDialogApparenceSkins.cpp : fichier d'implmentation
//

#include "resource.h"
#include "stdafx.h"
#include "AutDlg.h"
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogApparenceSkins.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "SeekDialog.h"
#include "In/MultiDllInput.h"
#include "Tools/cgfiltyp.h"
#include "Tools/Console.h"
#include "Tools/Draw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingDialogApparenceSkins

IMPLEMENT_MENUXP(CSettingsDialogApparenceSkins, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparenceSkins, CPropertyPage)

CSettingsDialogApparenceSkins::CSettingsDialogApparenceSkins() : CPropertyPage(CSettingsDialogApparenceSkins::IDD)
{
	includeSubDirectory = FALSE;
	changeSkinOnEachTrack = pMainFrame->changeSkinOnEachTrack;
	randomSkin = pMainFrame->randomSkin;
}

CSettingsDialogApparenceSkins::~CSettingsDialogApparenceSkins()
{
}


void CSettingsDialogApparenceSkins::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Check(pDX, IDC_INCLUDESUBDIRECTORY, includeSubDirectory);
	DDX_Control(pDX, IDC_L_SKINS, m_ListSkin);
	DDX_Check(pDX, IDC_CHANGESKINONEACHTRACK, changeSkinOnEachTrack);
	DDX_Check(pDX, IDC_RANDOMSKIN, randomSkin);
	DDX_Control(pDX, IDC_SAVESKINBROWSE, m_btnSave);
	DDX_Control(pDX, IDC_DELETESKINFROMSELECTION, m_btnDelete);
	DDX_Control(pDX, IDC_USEDEFAULTSKIN, m_btnUseDefault);
	DDX_Control(pDX, IDC_SKINDIRECTORYBROWSE, m_btnBrowse);
	DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
}

BOOL CSettingsDialogApparenceSkins::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE_SKINS);
	m_Helper.translateDlgItemText(this, IDC_LSKINDIRECTORY);
	m_Helper.translateDlgItemText(this, IDC_SKINDIRECTORYBROWSE);
	m_Helper.translateDlgItemText(this, IDC_INCLUDESUBDIRECTORY);
	m_Helper.translateDlgItemText(this, IDC_SAVESKINBROWSE);
	m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_CHANGESKINONEACHTRACK);
	m_Helper.translateDlgItemText(this, IDC_RANDOMSKIN);
	m_Helper.translateDlgItemText(this, IDC_USEDEFAULTSKIN);
	m_Helper.translateDlgItemText(this, IDC_DELETESKINFROMSELECTION);
	for (int i = 0; i < pMainFrame->CurrentSkin.GetSize(); i++)
	{
		if (pMainFrame->CurrentSkin[i].GetLength() != 0 && pMainFrame->CurrentSkin[i] != _T("NONE"))
		{
			if (m_ListSkin.FindString(0, pMainFrame->CurrentSkin[i]) == -1)
			{
				m_ListSkin.AddString(pMainFrame->CurrentSkin[i]);
			}
		}
		else
		{
			CString tmp = m_Helper.MyLoadString(IDS_DEFAULTSKIN);
			if (m_ListSkin.FindString(0, tmp) == -1)
			{
				m_ListSkin.AddString(tmp);
			}
		}
	}
	m_ListSkin.SetSel(pMainFrame->CurrentSkinSel, TRUE);

	SettingsDialog->m_tooltip->AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
	SettingsDialog->m_tooltip->SetNotify();

	SettingsDialog->CurrentSkinSel = pMainFrame->CurrentSkinSel;
	if (m_ListSkin.GetCount() != 0)
	{
		CString buf;
		m_ListSkin.GetText(SettingsDialog->CurrentSkinSel, buf);
		pMainFrame->LoadSkin(buf, &SettingsDialog->loadSkin);
	}
	else
	{
		pMainFrame->LoadSkin("", &SettingsDialog->loadSkin);
	}
	m_ListSkin.SetCurSel(SettingsDialog->CurrentSkinSel);

	GetDlgItem(IDC_RANDOMSKIN)->EnableWindow(changeSkinOnEachTrack);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogApparenceSkins::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->CurrentSkin.RemoveAll();
	for (int i = 0; i < m_ListSkin.GetCount(); i++)
	{
		CString buf;
		m_ListSkin.GetText(i, buf);
		pMainFrame->CurrentSkin.Add(buf);
	}
	pMainFrame->CurrentSkinSel = SettingsDialog->CurrentSkinSel;
	if (pMainFrame->CurrentSkin.GetSize() != 0)
	{
		pMainFrame->CurrentSkinSel %= pMainFrame->CurrentSkin.GetSize();
		pMainFrame->LoadSkin(pMainFrame->CurrentSkin[pMainFrame->CurrentSkinSel], &pMainFrame->mySkin);
	}
	else
	{
		pMainFrame->LoadSkin("", &pMainFrame->mySkin);
	}
	pMainFrame->changeSkinOnEachTrack = changeSkinOnEachTrack;
	pMainFrame->randomSkin = randomSkin;

	CPropertyPage::OnOK();
}

void CSettingsDialogApparenceSkins::OnPaint()
{
	CPropertyPage::OnPaint();
	CPaintDC dc(this);
	CWnd* pWnd = GetDlgItem(IDC_SKINSAMPLE);
	SettingsDialog->DisplaySkin(pWnd, -1, FALSE);
	pWnd = GetDlgItem(IDC_SKINTEXT);
	SettingsDialog->DisplaySkin(pWnd, -1, TRUE);
	pWnd = GetDlgItem(IDC_GRADIENTSAMPLE);
	SettingsDialog->m_SettingsDialogApparence.DrawGradientSample(pWnd);
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparenceSkins, CPropertyPage)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_SKINDIRECTORYBROWSE, OnSkinDirectoryBrowse)
	ON_BN_CLICKED(IDC_SAVESKINBROWSE, OnSaveSkin)
	ON_LBN_SELCHANGE(IDC_L_SKINS, OnLbnSelchangeLSkins)
	ON_BN_CLICKED(IDC_DELETESKINFROMSELECTION, OnBnClickedDeleteskinfromselection)
	ON_BN_CLICKED(IDC_USEDEFAULTSKIN, OnBnClickedUsedefaultskin)
	ON_BN_CLICKED(IDC_CHANGESKINONEACHTRACK, OnBnClickedChangeskinoneachtrack)
END_MESSAGE_MAP()

void CSettingsDialogApparenceSkins::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect rect;
	CWnd* pWnd = GetDlgItem(IDC_SKINSAMPLE);
	pWnd->GetWindowRect(&rect);
	ScreenToClient(rect);
	if (rect.PtInRect(point))
	{
		int frg = -1;
		frg = 5 * (point.y - rect.top) / rect.Height();
		SettingsDialog->DisplaySkin(pWnd, frg, FALSE);
	}
	else
	{
		SettingsDialog->DisplaySkin(pWnd, -1, FALSE);
	}
	pWnd = GetDlgItem(IDC_SKINTEXT);
	pWnd->GetWindowRect(&rect);
	ScreenToClient(rect);
	if (rect.PtInRect(point))
	{
		int frg = -1;
		frg = 5 * (point.y - rect.top) / rect.Height();
		SettingsDialog->DisplaySkin(pWnd, frg, TRUE);
	}
	else
	{
		SettingsDialog->DisplaySkin(pWnd, -1, TRUE);
	}
}

void CSettingsDialogApparenceSkins::OnSkinDirectoryBrowse()
{
	UpdateData(TRUE);
	LPMALLOC pMalloc;
	if (SHGetMalloc(&pMalloc) != NOERROR)
		return;

	BROWSEINFO bi;
	TCHAR buf[MAX_PATH];
	_tcscpy(buf, pMainFrame->InitDir.GetString());

	CString title;
	title = m_Helper.MyLoadString(IDS_OPENFOLDER);

	bi.hwndOwner = m_hWnd;
	bi.pszDisplayName = buf;
	bi.pidlRoot = NULL;
	bi.lpszTitle = LPCTSTR(title);
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = NULL;

	LPITEMIDLIST pidl;
	if ((pidl = SHBrowseForFolder(&bi)) == NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	if (SHGetPathFromIDList(pidl, buf) == false)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();

	CString theDir;
	theDir.Format(_T("%s\\"), buf);
	GetDlgItem(IDC_SKINDIRECTORY)->SetWindowText(theDir.GetString());
	FindSkin(theDir);
}

void CSettingsDialogApparenceSkins::FindSkin(CString path)
{
	CFileFind finder;
	CString fp, fext;
	CString posExt = _T("SKN;SK2;");
	BOOL bWorking = finder.FindFile(path + "\\*.*");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		fp = finder.GetFilePath();
		fext = fp.Mid(fp.ReverseFind('.') + 1, 3);
		fext.MakeUpper();
		fext += ";";
		if (posExt.Find(fext) != -1)
		{
			if (finder.GetLength() > 0)
			{
				if (m_ListSkin.FindString(0, fp) == -1)
					m_ListSkin.AddString(fp);
				continue;
			}
		}
		if (finder.IsDirectory() && !finder.IsDots() && includeSubDirectory == TRUE)
			FindSkin(fp + "\\");
	}
}

void CSettingsDialogApparenceSkins::OnSaveSkin()
{
	CFileDialog dialog(FALSE, _T("sk2"), _T(""), OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_SAVESKIN));

	if (dialog.DoModal() == IDOK)
	{
		CString m_file = dialog.GetPathName();

		SettingsDialog->m_SettingsDialogApparence.UpdateData(TRUE);
		SettingsDialog->m_SettingsDialogApparenceSkins.UpdateData(TRUE);
		SettingsDialog->m_SettingsDialogApparenceTooltip.UpdateData(TRUE);

		if (m_ListSkin.FindString(0, m_file) == -1)
			m_ListSkin.AddString(m_file);

		WritePrivateProfileString(_T("Skin"), _T("PlayIcon"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.PlayIconName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("PauseIcon"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.PauseIconName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("StopIcon"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.StopIconName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("PrevIcon"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.PrevIconName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("NextIcon"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.NextIconName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("Buttons"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.ButtonsName), m_file);
		WritePrivateProfileString(_T("Skin"), _T("ButtonsDn"), CopyResourceForSkin(m_file, SettingsDialog->loadSkin.ButtonsDnName), m_file);

		SettingsDialog->loadSkin.startColor = SettingsDialog->m_SettingsDialogApparence.startColor.GetColour();
		SettingsDialog->loadSkin.endColor = SettingsDialog->m_SettingsDialogApparence.endColor.GetColour();
		SettingsDialog->loadSkin.m_border_color = SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_color.GetColour();
		SettingsDialog->loadSkin.m_end_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_end_bk.GetColour();
		SettingsDialog->loadSkin.m_mid_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_mid_bk.GetColour();
		SettingsDialog->loadSkin.m_start_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_start_bk.GetColour();

		WritePrivateProfileString(_T("Skin"), _T("GradientStart"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.startColor), m_file);
		WritePrivateProfileString(_T("Skin"), _T("GradientEnd"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.endColor), m_file);
		WritePrivateProfileString(_T("Skin"), _T("border_color"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.m_border_color), m_file);
		WritePrivateProfileString(_T("Skin"), _T("end_bk"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.m_end_bk), m_file);
		WritePrivateProfileString(_T("Skin"), _T("mid_bk"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.m_mid_bk), m_file);
		WritePrivateProfileString(_T("Skin"), _T("start_bk"), m_Helper.ConvertColorHexa(SettingsDialog->loadSkin.m_start_bk), m_file);

		CString tmp;
		tmp = SettingsDialog->toolTipText;
		tmp.Replace(_T("\r\n"), _T("\\r\\n"));
		tmp.Replace(_T("\n"), _T("\\n"));
		tmp.Replace(_T("\t"), _T("\\t"));
		WritePrivateProfileString(_T("Skin"), _T("ToolTipText"), tmp, m_file);

		SettingsDialog->loadSkin.m_theme = SettingsDialog->m_SettingsDialogApparenceTooltip.m_theme;
		SettingsDialog->loadSkin.m_effect_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_effect_bk;
		SettingsDialog->loadSkin.m_granularity = SettingsDialog->m_SettingsDialogApparenceTooltip.m_granularity;
		SettingsDialog->loadSkin.m_border = SettingsDialog->m_SettingsDialogApparenceTooltip.m_border;
		SettingsDialog->loadSkin.m_custom_border = SettingsDialog->m_SettingsDialogApparenceTooltip.m_custom_border;
		SettingsDialog->loadSkin.m_border_width = SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_width;
		SettingsDialog->loadSkin.m_border_height = SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_height;
		SettingsDialog->loadSkin.m_transparency = SettingsDialog->m_SettingsDialogApparenceTooltip.m_transparency;


		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_theme);
		WritePrivateProfileString(_T("Skin"), _T("Theme"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_effect_bk);
		WritePrivateProfileString(_T("Skin"), _T("effect_bk"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_granularity);
		WritePrivateProfileString(_T("Skin"), _T("granularity"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_border);
		WritePrivateProfileString(_T("Skin"), _T("border"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_custom_border);
		WritePrivateProfileString(_T("Skin"), _T("custom_border"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_border_width);
		WritePrivateProfileString(_T("Skin"), _T("border_width"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_border_height);
		WritePrivateProfileString(_T("Skin"), _T("border_height"), tmp, m_file);
		tmp.Format(_T("%d"), SettingsDialog->loadSkin.m_transparency);
		WritePrivateProfileString(_T("Skin"), _T("transparency"), tmp, m_file);

		UpdateData(FALSE);
	}
}

CString CSettingsDialogApparenceSkins::CopyResourceForSkin(CString skinPath, CString resourcePath)
{
	TCHAR pathFile[MAX_PATH];
	TCHAR pathName[MAX_PATH];
	TCHAR driveFile[MAX_PATH];
	TCHAR driveName[MAX_PATH];
	TCHAR directoryFile[MAX_PATH];
	TCHAR directoryName[MAX_PATH];
	TCHAR fileName[MAX_PATH];
	TCHAR extName[MAX_PATH];

	CString saveName = resourcePath;

	if (saveName.GetLength() != 0)
	{
		_tcscpy(pathFile, (TCHAR *)skinPath.GetString());
		_tcscpy(pathName, (TCHAR *)resourcePath.GetString());

		_tsplitpath(pathFile, driveFile, directoryFile, NULL, NULL);
		_tsplitpath(pathName, driveName, directoryName, fileName, extName);

		if (_tcscmp(driveFile, driveName) == 0)
		{
			if (_tcsstr(directoryName, directoryFile) != NULL)
			{
				saveName = resourcePath.Right(resourcePath.GetLength() - _tcslen(driveFile) - _tcslen(directoryFile));
			}
			else
			{
				saveName.Format(_T("%s%s%s%s"), driveFile, directoryFile, fileName, extName);
				CopyFile(resourcePath, saveName, FALSE);
				saveName.Format(_T("%s%s"), fileName, extName);
			}
		}
		else
		{
			saveName.Format(_T("%s%s%s%s"), driveFile, directoryFile, fileName, extName);
			CopyFile(resourcePath, saveName, FALSE);
			saveName.Format(_T("%s%s"), fileName, extName);
		}
	}
	return saveName;
}

void CSettingsDialogApparenceSkins::OnLbnSelchangeLSkins()
{
	// TODO : ajoutez ici le code de votre gestionnaire de notification de contrle
	if (m_ListSkin.GetCurSel() != -1)
	{
		CString buf;
		m_ListSkin.GetText(m_ListSkin.GetCurSel(), buf);
		SettingsDialog->CurrentSkinSel = m_ListSkin.GetCurSel();

		SettingsDialog->loadSkin.startColor = SettingsDialog->m_SettingsDialogApparence.startColor.GetColour();
		SettingsDialog->loadSkin.endColor = SettingsDialog->m_SettingsDialogApparence.endColor.GetColour();
		SettingsDialog->loadSkin.m_border_color = SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_color.GetColour();
		SettingsDialog->loadSkin.m_end_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_end_bk.GetColour();
		SettingsDialog->loadSkin.m_mid_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_mid_bk.GetColour();
		SettingsDialog->loadSkin.m_start_bk = SettingsDialog->m_SettingsDialogApparenceTooltip.m_start_bk.GetColour();

		pMainFrame->LoadSkin(buf, &SettingsDialog->loadSkin);
		pMainFrame->UseSkin(&SettingsDialog->loadSkin);

		SettingsDialog->m_SettingsDialogApparence.startColor.SetColour(SettingsDialog->loadSkin.startColor);
		SettingsDialog->m_SettingsDialogApparence.endColor.SetColour(SettingsDialog->loadSkin.endColor);
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_theme = SettingsDialog->loadSkin.m_theme;
		SettingsDialog->m_SettingsDialogApparenceTooltip.UpdateData(FALSE);

		SettingsDialog->m_SettingsDialogApparenceTooltip.OnChangeColorTheme();
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_color.SetColour(SettingsDialog->loadSkin.m_border_color);
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_end_bk.SetColour(SettingsDialog->loadSkin.m_end_bk);
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_mid_bk.SetColour(SettingsDialog->loadSkin.m_mid_bk);
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_start_bk.SetColour(SettingsDialog->loadSkin.m_start_bk);

		SettingsDialog->toolTipText = SettingsDialog->loadSkin.toolTipText;
		SettingsDialog->toolTipText.Replace(_T("\\r\\n"), _T("\r\n"));
		SettingsDialog->toolTipText.Replace(_T("\\n"), _T("\n"));
		SettingsDialog->toolTipText.Replace(_T("\\t"), _T("\t"));
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_effect_bk = SettingsDialog->loadSkin.m_effect_bk;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_granularity = SettingsDialog->loadSkin.m_granularity;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_border = SettingsDialog->loadSkin.m_border;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_custom_border = SettingsDialog->loadSkin.m_custom_border;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_width = SettingsDialog->loadSkin.m_border_width;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_border_height = SettingsDialog->loadSkin.m_border_height;
		SettingsDialog->m_SettingsDialogApparenceTooltip.m_transparency = SettingsDialog->loadSkin.m_transparency;
		SettingsDialog->m_SettingsDialogApparenceTooltip.UpdateData(FALSE);

		SettingsDialog->m_SettingsDialogApparenceTooltip.OnSetBorder();
		SettingsDialog->m_SettingsDialogApparenceTooltip.OnChangeColorBk();
		SettingsDialog->m_SettingsDialogApparenceTooltip.OnChangeTransparency();
		SettingsDialog->m_SettingsDialogApparenceTooltip.OnChangeEffect();
		SettingsDialog->m_SettingsDialogApparenceTooltip.OnSetBorder();
		SettingsDialog->m_tooltip->AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);

		CWnd* pWnd = GetDlgItem(IDC_SKINSAMPLE);
		SettingsDialog->DisplaySkin(pWnd, -1, FALSE);
		pWnd = GetDlgItem(IDC_SKINTEXT);
		SettingsDialog->DisplaySkin(pWnd, -1, TRUE);
		pWnd = GetDlgItem(IDC_GRADIENTSAMPLE);
		SettingsDialog->m_SettingsDialogApparence.DrawGradientSample(pWnd);
	}
}

BOOL CSettingsDialogApparenceSkins::PreTranslateMessage(MSG* pMsg)
{
	SettingsDialog->m_tooltip->RelayEvent(pMsg);

	return CPropertyPage::PreTranslateMessage(pMsg);
}


void CSettingsDialogApparenceSkins::OnBnClickedDeleteskinfromselection()
{
	if (m_ListSkin.GetCurSel() != -1)
	{
		int cur = m_ListSkin.GetCurSel();
		m_ListSkin.DeleteString(m_ListSkin.GetCurSel());
		m_ListSkin.SetCurSel(cur - 1);
		OnLbnSelchangeLSkins();
	}
}

void CSettingsDialogApparenceSkins::OnBnClickedUsedefaultskin()
{
	CString tmp = m_Helper.MyLoadString(IDS_DEFAULTSKIN);
	if (m_ListSkin.FindString(0, tmp) == -1)
		m_ListSkin.AddString(tmp);

	m_ListSkin.SetCurSel(m_ListSkin.FindString(0, tmp));
	OnLbnSelchangeLSkins();
}

void CSettingsDialogApparenceSkins::OnBnClickedChangeskinoneachtrack()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_RANDOMSKIN)->EnableWindow(changeSkinOnEachTrack);
}
