// SettingsDialogApparenceTooltip.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogApparenceTooltip.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "SeekDialog.h"
#include "AutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogApparenceTooltip

IMPLEMENT_MENUXP(CSettingsDialogApparenceTooltip, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparenceTooltip, CPropertyPage)

CSettingsDialogApparenceTooltip::CSettingsDialogApparenceTooltip() : CPropertyPage(CSettingsDialogApparenceTooltip::IDD)
{
	m_border = pMainFrame->mySkin.m_border;
	m_custom_border = pMainFrame->mySkin.m_custom_border;
	m_end_bk.SetColour(pMainFrame->mySkin.m_end_bk);
	m_border_width = pMainFrame->mySkin.m_border_width;
	m_border_height = pMainFrame->mySkin.m_border_height;
	m_border_color.SetColour(pMainFrame->mySkin.m_border_color);
	m_start_bk.SetColour(pMainFrame->mySkin.m_start_bk);
	m_mid_bk.SetColour(pMainFrame->mySkin.m_mid_bk);
	m_effect_bk = pMainFrame->mySkin.m_effect_bk;
	m_granularity = pMainFrame->mySkin.m_granularity;
	m_transparency = pMainFrame->mySkin.m_transparency;
	m_theme = pMainFrame->mySkin.m_theme;

	m_show_time = pMainFrame->m_show_time;
	m_hide_time = pMainFrame->m_hide_time;
	m_fade_in = pMainFrame->m_fade_in;
	m_fade_out = pMainFrame->m_fade_out;
	m_animation = pMainFrame->m_animation;
}

CSettingsDialogApparenceTooltip::~CSettingsDialogApparenceTooltip()
{
}

void CSettingsDialogApparenceTooltip::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_BUTTON4, m_border_color);
	DDX_Control(pDX, IDC_BUTTON3, m_end_bk);
	DDX_Control(pDX, IDC_BUTTON2, m_mid_bk);
	DDX_Control(pDX, IDC_BUTTON1, m_start_bk);
	DDX_CBIndex(pDX, IDC_TYPE, m_theme);
	DDX_CBIndex(pDX, IDC_BACKGROUND, m_effect_bk);
	DDX_Text(pDX, IDC_CHANGEGRANULARITY, m_granularity);
	DDV_MinMaxByte(pDX, m_granularity, 0, 255);
	DDX_Check(pDX, IDC_CHECKBORDER, m_border);
	DDX_Text(pDX, IDC_CHANGEWIDTH, m_border_width);
	DDX_Text(pDX, IDC_CHANGEHEIGHT, m_border_height);
	DDX_Text(pDX, IDC_CHANGETRANSPARENCY, m_transparency);
	DDX_Text(pDX, IDC_CHANGESHOWTIME, m_show_time);
	DDX_Text(pDX, IDC_CHANGEHIDETIME, m_hide_time);
	DDX_Text(pDX, IDC_CHANGEFADEIN, m_fade_in);
	DDX_Text(pDX, IDC_CHANGEFADEOUT, m_fade_out);
	DDX_Text(pDX, IDC_CHANGEANIMATION, m_animation);
	DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
	DDX_Control(pDX, IDC_TYPE, m_type);
	DDX_Control(pDX, IDC_BACKGROUND, m_background);
}

BOOL CSettingsDialogApparenceTooltip::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE_TOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LBACKGROUNDEFFECT);
	m_Helper.translateDlgItemText(this, IDC_LTYPE);
	m_Helper.translateDlgItemText(this, IDC_LSTART);
	m_Helper.translateDlgItemText(this, IDC_LMID);
	m_Helper.translateDlgItemText(this, IDC_LEND);
	m_Helper.translateDlgItemText(this, IDC_LGRANULARITY);
	m_Helper.translateDlgItemText(this, IDC_LTRANSPARENCY);
	m_Helper.translateDlgItemText(this, IDC_LCOLORS);
	m_Helper.translateDlgItemText(this, IDC_LCOLORTHEME);
	m_Helper.translateDlgItemText(this, IDC_LTIMERS);
	m_Helper.translateDlgItemText(this, IDC_LBORDER);
	m_Helper.translateDlgItemText(this, IDC_LWIDTH);
	m_Helper.translateDlgItemText(this, IDC_LHEIGHT);
	m_Helper.translateDlgItemText(this, IDC_LSHOWAFTER);
	m_Helper.translateDlgItemText(this, IDC_LHIDEAFTER);
	m_Helper.translateDlgItemText(this, IDC_LFADEIN);
	m_Helper.translateDlgItemText(this, IDC_LFADEOUT);
	m_Helper.translateDlgItemText(this, IDC_LANIMATION);
	m_Helper.translateDlgItemText(this, IDC_CHECKBORDER);
	m_Helper.translateDlgItemText(this, IDC_RADIO1);
	m_Helper.translateDlgItemText(this, IDC_RADIO2);
	m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);

	m_type.AddString(m_Helper.MyLoadString(IDS_TYPESTANDARD));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPESILVER));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEBUTTON));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEEXOTIC));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEAQUA));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPECHROME));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEGOLD));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPESUNNY));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEJUNGLE));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPESKY));
	m_type.AddString(m_Helper.MyLoadString(IDS_TYPEFIRE));
	m_type.SetCurSel(m_theme);

	SettingsDialog->m_tooltip->AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
	SettingsDialog->m_tooltip->SetNotify();

	OnChangeColorTheme();
	OnChangeEffect();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogApparenceTooltip::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->mySkin.m_border_color = m_border_color.GetColour();
	pMainFrame->mySkin.m_end_bk = m_end_bk.GetColour();
	pMainFrame->mySkin.m_mid_bk = m_mid_bk.GetColour();
	pMainFrame->mySkin.m_start_bk = m_start_bk.GetColour();

	pMainFrame->mySkin.m_theme = m_theme;
	pMainFrame->mySkin.m_effect_bk = m_effect_bk;
	pMainFrame->mySkin.m_granularity = m_granularity;
	pMainFrame->mySkin.m_border = m_border;
	pMainFrame->mySkin.m_custom_border = m_custom_border;
	pMainFrame->mySkin.m_border_width = m_border_width;
	pMainFrame->mySkin.m_border_height = m_border_height;
	pMainFrame->mySkin.m_transparency = m_transparency;
	pMainFrame->m_show_time = m_show_time;
	pMainFrame->m_hide_time = m_hide_time;
	pMainFrame->m_fade_in = m_fade_in;
	pMainFrame->m_fade_out = m_fade_out;
	pMainFrame->m_animation = m_animation;

	CPropertyPage::OnOK();
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparenceTooltip, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_TYPE, OnChangeColorTheme)
	ON_CBN_SELCHANGE(IDC_BACKGROUND, OnChangeEffect)
	ON_BN_CLICKED(IDC_BACKGROUND, OnShowBorder)
	ON_EN_CHANGE(IDC_CHANGEGRANULARITY, OnChangeEffect)
	ON_EN_CHANGE(IDC_CHANGEWIDTH, OnSetBorder)
	ON_EN_CHANGE(IDC_CHANGEHEIGHT, OnSetBorder)
	ON_BN_CLICKED(IDC_RADIO1, OnSetBorder)
	ON_BN_CLICKED(IDC_RADIO2, OnSetBorder)
	ON_EN_CHANGE(IDC_CHANGETRANSPARENCY, OnChangeTransparency)
	ON_EN_CHANGE(IDC_CHANGESHOWTIME, OnChangeTimers)
	ON_EN_CHANGE(IDC_CHANGEHIDETIME, OnChangeTimers)
	ON_EN_CHANGE(IDC_CHANGEFADEIN, OnChangeTimers)
	ON_EN_CHANGE(IDC_CHANGEFADEOUT, OnChangeTimers)
	ON_EN_CHANGE(IDC_CHANGEANIMATION, OnChangeAniStep)
	ON_MESSAGE(CPN_SELENDOK, OnChangeColorBk)
	ON_BN_CLICKED(IDC_CHECKBORDER, OnSetBorder)
END_MESSAGE_MAP()

LONG CSettingsDialogApparenceTooltip::OnChangeColorBk(UINT lParam, LONG wParam)
{
	SettingsDialog->m_tooltip->SetColorBk(m_start_bk.GetColour(), m_mid_bk.GetColour(), m_end_bk.GetColour());
	OnSetBorder();
	return 0L;
}

void CSettingsDialogApparenceTooltip::OnChangeColorTheme()
{
	UpdateData(TRUE);
	switch (m_theme)
	{
	case 0:
		//Standard
		m_start_bk.SetColour(RGB(255, 255, 223));
		m_mid_bk.SetColour(RGB(192, 192, 172));
		m_end_bk.SetColour(RGB(128, 128, 112));
		break;
	case 1:
		//Silver
		m_start_bk.SetColour(RGB(255, 255, 255));
		m_mid_bk.SetColour(RGB(240, 247, 255));
		m_end_bk.SetColour(RGB(192, 192, 208));
		break;
	case 2:
		//Button
		m_start_bk.SetColour(RGB(223, 223, 223));
		m_mid_bk.SetColour(RGB(191, 191, 191));
		m_end_bk.SetColour(RGB(127, 127, 127));
		break;
	case 3:
		//Exotic
		m_start_bk.SetColour(RGB(0, 255, 255));
		m_mid_bk.SetColour(RGB(255, 255, 0));
		m_end_bk.SetColour(RGB(0, 255, 0));
		break;
	case 4:
		//Aqua
		m_start_bk.SetColour(RGB(123, 158, 198));
		m_mid_bk.SetColour(RGB(173, 207, 247));
		m_end_bk.SetColour(RGB(198, 239, 255));
		break;
	case 5:
		//Chrome
		m_start_bk.SetColour(RGB(231, 251, 255));
		m_mid_bk.SetColour(RGB(214, 211, 214));
		m_end_bk.SetColour(RGB(165, 162, 173));
		break;
	case 6:
		//Gold
		m_start_bk.SetColour(RGB(255, 255, 148));
		m_mid_bk.SetColour(RGB(255, 231, 132));
		m_end_bk.SetColour(RGB(255, 207, 0));
		break;
	case 7:
		//Sunny
		m_start_bk.SetColour(RGB(255, 248, 229));
		m_mid_bk.SetColour(RGB(255, 209, 115));
		m_end_bk.SetColour(RGB(255, 156, 0));
		break;
	case 8:
		//Jungle
		m_start_bk.SetColour(RGB(214, 250, 183));
		m_mid_bk.SetColour(RGB(148, 236, 104));
		m_end_bk.SetColour(RGB(4, 202, 0));
		break;
	case 9:
		//Sky
		m_start_bk.SetColour(RGB(203, 233, 254));
		m_mid_bk.SetColour(RGB(88, 175, 241));
		m_end_bk.SetColour(RGB(0, 67, 202));
		break;
	case 10:
		//Fire
		m_start_bk.SetColour(RGB(255, 255, 0));
		m_mid_bk.SetColour(RGB(255, 104, 32));
		m_end_bk.SetColour(RGB(194, 3, 0));
		break;
	}
	OnChangeColorBk();
}

void CSettingsDialogApparenceTooltip::OnChangeEffect()
{
	UpdateData();
	SettingsDialog->m_tooltip->SetEffectBk(m_effect_bk, m_granularity);
}

void CSettingsDialogApparenceTooltip::OnShowBorder()
{
	OnSetBorder();
}

void CSettingsDialogApparenceTooltip::OnSetBorder()
{
	UpdateData();
	m_border_color.EnableWindow(m_border);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(m_border);
	GetDlgItem(IDC_RADIO1)->EnableWindow(m_border);
	GetDlgItem(IDC_RADIO2)->EnableWindow(m_border);
	GetDlgItem(IDC_CHANGEWIDTH)->EnableWindow(m_border);
	GetDlgItem(IDC_CHANGEHEIGHT)->EnableWindow(m_border);
	if (m_border)
	{
		if (!m_custom_border)
			SettingsDialog->m_tooltip->SetBorder(m_end_bk.GetColour(), m_border_width, m_border_height);
		else
			SettingsDialog->m_tooltip->SetBorder(m_border_color.GetColour(), m_border_width, m_border_height);
	}
	else
	{
		SettingsDialog->m_tooltip->HideBorder();
	} //if
}

BOOL CSettingsDialogApparenceTooltip::PreTranslateMessage(MSG* pMsg)
{
	SettingsDialog->m_tooltip->RelayEvent(pMsg);

	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CSettingsDialogApparenceTooltip::OnChangeTransparency()
{
	UpdateData();
	SettingsDialog->m_tooltip->SetTransparency(m_transparency);
}

void CSettingsDialogApparenceTooltip::OnChangeTimers()
{
	UpdateData();
	SettingsDialog->m_tooltip->SetDelayTime(PPTOOLTIP_TIME_INITIAL, m_show_time);
	SettingsDialog->m_tooltip->SetDelayTime(PPTOOLTIP_TIME_AUTOPOP, m_hide_time);
	SettingsDialog->m_tooltip->SetDelayTime(PPTOOLTIP_TIME_FADEIN, m_fade_in);
	SettingsDialog->m_tooltip->SetDelayTime(PPTOOLTIP_TIME_FADEOUT, m_fade_out);
}

void CSettingsDialogApparenceTooltip::OnChangeAniStep()
{
	UpdateData();
	SettingsDialog->m_tooltip->SetDelayTime(PPTOOLTIP_TIME_ANIMATION, m_animation);
}

