#ifndef APPLICATION_H
#define APPLICATION_H

#include <api/application/api_application.h>

class CApplication : public api_application
{
public :
	const wchar_t* _main_getAppName(); // returns (e.g.) "Winamp"
	const wchar_t* _main_getVersionString(); // returns (e.g.) "Winamp 5.12"	
	const wchar_t* _main_getVersionNumString();  // returns (e.g.) "5.12"
	unsigned int _main_getBuildNumber(); // returns (e.g.) 666
	GUID _main_getGUID();
	HANDLE _main_getMainThreadHandle();
	HINSTANCE _main_gethInstance();
	const wchar_t* _main_getCommandLine();
	void _main_shutdown(int deferred = TRUE);
	void _main_cancelShutdown();
	int _main_isShuttingDown();
	const wchar_t* _path_getAppPath();
	const wchar_t* _path_getUserSettingsPath();
	int _app_getInitCount();
	intptr_t _app_messageLoopStep();
	void _app_addMessageProcessor(api_messageprocessor* processor);
	void _app_removeMessageProcessor(api_messageprocessor* processor);
	void _app_addModelessDialog(HWND hwnd);
	void _app_removeModelessDialog(HWND hwnd);

#undef CBCLASS
#define CBCLASS CApplication
	START_DISPATCH;
	CB(API_APPLICATION_MAIN_GETAPPNAME, _main_getAppName);
	CB(API_APPLICATION_MAIN_GETVERSIONSTRING, _main_getVersionString);
	CB(API_APPLICATION_MAIN_GETVERSIONSTRING2, _main_getVersionNumString);
	CB(API_APPLICATION_MAIN_GETBUILDNUMBER, _main_getBuildNumber);
	CB(API_APPLICATION_MAIN_GETGUID, _main_getGUID);
	CB(API_APPLICATION_MAIN_GETMAINTHREADHANDLE, _main_getMainThreadHandle);
	CB(API_APPLICATION_MAIN_GETHINSTANCE, _main_gethInstance);
	CB(API_APPLICATION_MAIN_GETCOMMANDLINE, _main_getCommandLine);
	VCB(API_APPLICATION_MAIN_SHUTDOWN, _main_shutdown);
	VCB(API_APPLICATION_MAIN_CANCELSHUTDOWN, _main_cancelShutdown);
	CB(API_APPLICATION_MAIN_ISSHUTTINGDOWN, _main_isShuttingDown);
	CB(API_APPLICATION_PATH_GETAPPPATH, _path_getAppPath);
	CB(API_APPLICATION_PATH_GETUSERSETTINGSPATH, _path_getUserSettingsPath);
	CB(API_APPLICATION_APP_GETINITCOUNT, _app_getInitCount);
	CB(API_APPLICATION_APP_MESSAGELOOPSTEP, _app_messageLoopStep);
	VCB(API_APPLICATION_APP_ADDMESSAGEPROCESSOR, _app_addMessageProcessor);
	VCB(API_APPLICATION_APP_REMOVEMESSAGEPROCESSOR, _app_removeMessageProcessor);
	VCB(API_APPLICATION_APP_ADDMODELESSDIALOG, _app_addModelessDialog);
	VCB(API_APPLICATION_APP_REMOVEMODELESSDIALOG, _app_removeModelessDialog);
	END_DISPATCH;
#undef CBCLASS
};

#endif