// ConfigDialog.cpp
//

#include "../stdafx.h"

#include <wa_ipc.h>

#include "TagInfo.h"
#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "ConfigDialog.h"
#include "PropertySheet.h"
#include "../Tools/ComboBoxXP.h"

#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CIn_mpg123dParam* prm;

static const int List_Bps[] =
{
	16, 24, 32, -32, -64
};

void reflect_setting(void);
void reflect_thread_setting(void);
CComboBoxXP m_comboDecoderPriority;
CComboBoxXP m_comboOutputBps;

BOOL CALLBACK in_config_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_ENABLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_FULLBUFFERING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_SUPZERO);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REVERSE_LR);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REVERSE_PHASE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_VOLUME);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_DISPAVG);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_THREADPRIORITY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_OUTPUTFORMAT);

			CPropertySheet* pSheet = DYNAMIC_DOWNCAST(CPropertySheet, CWnd::FromHandle(hDlg)->GetParent());
			CDataExchange dx(CWnd::FromHandle(hDlg), FALSE);
			CMenuXP::SetXPLookNFeel(CWnd::FromHandle(hDlg), CMenuXP::GetXPLookNFeel(CWnd::FromHandle(hDlg)->GetParent()->GetParent()));
			DDX_Control(&dx, IDC_COMBO_DECODER_PRIORITY, m_comboDecoderPriority);
			DDX_Control(&dx, IDC_COMBO_OUTPUTBPS, m_comboOutputBps);

			SendDlgItemMessage(hDlg, IDC_CH_ENABLE, BM_SETCHECK, prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED, 0);

			EnableWindow(GetDlgItem(hDlg, IDC_COMBO_DECODER_PRIORITY), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_COMBO_OUTPUTBPS), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_FULLBUFFERING), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_SUPZERO), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_REVERSE_LR), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_REVERSE_PHASE), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_VOLUME), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_CH_DISPAVG), prm->m_bEnable ? BST_CHECKED : BST_UNCHECKED);

			SendDlgItemMessage(hDlg, IDC_CH_FULLBUFFERING, BM_SETCHECK, prm->m_bFullBuffering ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_SUPZERO, BM_SETCHECK, prm->m_bSupZero ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REVERSE_LR, BM_SETCHECK, prm->m_bReverseLR ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REVERSE_PHASE, BM_SETCHECK, prm->m_bReversePhase ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_VOLUME, BM_SETCHECK, prm->m_bAltVolume ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_DISPAVG, BM_SETCHECK, prm->m_bDispAvg ? BST_CHECKED : BST_UNCHECKED, 0);

			CString buf = m_HelperIn.MyLoadString(IDS_LNORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LABOVENORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LHIGHEST);
			SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_SETCURSEL, prm->m_nDecodeThreadPriority, 0);

			buf = m_HelperIn.MyLoadString(IDS_L16BITSINT);
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_L24BITSINT);
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_L32BITSINT);
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_L32BITSFLOAT);
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_L64BITSFLOAT);
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_SETCURSEL, prm->m_nOutputBps, 0);
			for (int Idx = 0; Idx < 5; Idx++)
			{
				if (List_Bps[Idx] == prm->m_nOutputBps)
				{
					SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_SETCURSEL, Idx, 0);
					break;
				}
			}
			break;
		}
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_APPLY :
				{
					prm->m_bEnable = SendDlgItemMessage(hDlg, IDC_CH_ENABLE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bFullBuffering = SendDlgItemMessage(hDlg, IDC_CH_FULLBUFFERING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bSupZero = SendDlgItemMessage(hDlg, IDC_CH_SUPZERO, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bReverseLR = SendDlgItemMessage(hDlg, IDC_CH_REVERSE_LR, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bReversePhase = SendDlgItemMessage(hDlg, IDC_CH_REVERSE_PHASE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bAltVolume = SendDlgItemMessage(hDlg, IDC_CH_VOLUME, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bDispAvg = SendDlgItemMessage(hDlg, IDC_CH_DISPAVG, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;

					bool bFlag = false;

					if (prm->m_nDecodeThreadPriority != SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_GETCURSEL, 0, 0))
					{
						prm->m_nDecodeThreadPriority = SendDlgItemMessage(hDlg, IDC_COMBO_DECODER_PRIORITY, CB_GETCURSEL, 0, 0);
						bFlag = true;
					}

					if (prm->m_nOutputBps != List_Bps[SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_GETCURSEL, 0, 0)])
					{
						prm->m_nOutputBps = List_Bps[SendDlgItemMessage(hDlg, IDC_COMBO_OUTPUTBPS, CB_GETCURSEL, 0, 0)];
						bFlag = true;
					}

					if (bFlag)
					{
						::reflect_thread_setting();
					}
					::reflect_setting();
					break;
				}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CH_ENABLE:
			{
				prm->m_bEnable = SendDlgItemMessage(hDlg, IDC_CH_ENABLE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				EnableWindow(GetDlgItem(hDlg, IDC_COMBO_DECODER_PRIORITY), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_COMBO_OUTPUTBPS), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_FULLBUFFERING), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_SUPZERO), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_REVERSE_LR), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_REVERSE_PHASE), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_VOLUME), prm->m_bEnable);
				EnableWindow(GetDlgItem(hDlg, IDC_CH_DISPAVG), prm->m_bEnable);
				return FALSE;
			}
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}

	return TRUE;
}
