// StreamingDialog.cpp
//

#include "../stdafx.h"

#include "CommonFunc.h"

#include <wa_ipc.h>
#include "TagInfo.h"
#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "StreamingDialog.h"
#include "PropertySheet.h"
#include "../Tools/ButtonXP.h"
#include "../Tools/ComboBoxXP.h"

#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void reflect_setting(void);
void reflect_thread_setting(void);

CButtonXP m_btnBrowse;
CComboBoxXP m_comboPriority;

BOOL CALLBACK in_streaming_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_THRAD_PRIORITY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_BUFFER_SIZE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_HTTP_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_SAVE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_FORMAT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_EXAMPLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_ENABLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_SAVESTREAM);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_UDP);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_DECODE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_KB);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_BUTTON_FILEDIALOG);

			CDataExchange dx(CWnd::FromHandle(hDlg), FALSE);
			CMenuXP::SetXPLookNFeel(CWnd::FromHandle(hDlg), CMenuXP::GetXPLookNFeel(CWnd::FromHandle(hDlg)->GetParent()->GetParent()));
			DDX_Control(&dx, IDC_COMBO_PRIORITY, m_comboPriority);
			DDX_Control(&dx, IDC_BUTTON_FILEDIALOG, m_btnBrowse);

			SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_SETCHECK, prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED, 0);

			EnableWindow(GetDlgItem(hDlg, IDC_COMBO_PRIORITY), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_ED_STRBUF), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_PROXY), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), prm->m_bEnable && prm->m_bProxy && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_SAVESTREAM), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), prm->m_bEnable && prm->m_bSaveStream && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), prm->m_bEnable && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_ED_TITLESTREAMING_FORMAT), prm->m_bEnable && prm->m_bTitleStreaming && prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED);

			SendDlgItemMessage(hDlg, IDC_PROXY, BM_SETCHECK, prm->m_bProxy ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_SETCHECK, prm->m_bSaveStream ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_SETCHECK, prm->m_bTitleStreaming ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_SETCHECK, prm->m_bTitleStreamingUDP ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_SETCHECK, prm->m_bTitleStreamingDecode ? BST_CHECKED : BST_UNCHECKED, 0);
			SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, prm->m_strSaveStream);
			SetDlgItemText(hDlg, IDC_ED_PROXY, prm->m_strProxy);

			CString tmp;
			tmp.Format(_T("%d"), prm->m_nBufferLength);
			SetDlgItemText(hDlg, IDC_ED_STRBUF, tmp);
			SetDlgItemText(hDlg, IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

			CString buf = m_HelperIn.MyLoadString(IDS_LNORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LABOVENORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LHIGHEST);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_SETCURSEL, prm->m_nReceiveThreadPriority, 0);
			break;
		}
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_SETACTIVE:
				{
					BOOL check = prm->m_bEnable && SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED;
					EnableWindow(GetDlgItem(hDlg, IDC_CH_ENABLE_STREAMING), prm->m_bEnable);
					EnableWindow(GetDlgItem(hDlg, IDC_COMBO_PRIORITY), check);
					EnableWindow(GetDlgItem(hDlg, IDC_ED_STRBUF), check);
					EnableWindow(GetDlgItem(hDlg, IDC_PROXY), check);
					EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), prm->m_bProxy && check);
					EnableWindow(GetDlgItem(hDlg, IDC_SAVESTREAM), check);
					EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), prm->m_bSaveStream && check);
					EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING), check);
					EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), check);
					EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), check);
					EnableWindow(GetDlgItem(hDlg, IDC_ED_TITLESTREAMING_FORMAT), prm->m_bTitleStreaming && check);
					break;
				}
			case PSN_APPLY :
				{
					prm->m_bEnableStreaming = SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bProxy = SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bSaveStream = SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreaming = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreamingUDP = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreamingDecode = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_PROXY, prm->m_strProxy);
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_SAVESTREAM, prm->m_strSaveStream);
					CString tmp;
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_STRBUF, tmp);
					prm->m_nBufferLength = Max(_tstoi(tmp), MIN_STREAM_SIZE / 1024);
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

					bool bFlag = false;

					if (prm->m_nReceiveThreadPriority != SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0))
					{
						prm->m_nReceiveThreadPriority = SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0);
						bFlag = true;
					}
					if (bFlag)
					{
						::reflect_thread_setting();
					}
					::reflect_setting();
					break;
				}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CH_ENABLE_STREAMING:
			{
				BOOL check = SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED;
				EnableWindow(GetDlgItem(hDlg, IDC_COMBO_PRIORITY), check);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_STRBUF), check);
				EnableWindow(GetDlgItem(hDlg, IDC_PROXY), check);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), prm->m_bProxy && check);
				EnableWindow(GetDlgItem(hDlg, IDC_SAVESTREAM), check);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), prm->m_bSaveStream && check);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING), check);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), check);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), check);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_TITLESTREAMING_FORMAT), prm->m_bTitleStreaming && check);
				return FALSE;
			}
		case IDC_PROXY:
			{
				BOOL check = SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), check);
				return FALSE;
			}
		case IDC_SAVESTREAM:
			{
				BOOL check = SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), check);
				EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FILEDIALOG), check);
				return FALSE;
			}
		case IDC_TITLESTREAMING:
			{
				BOOL check = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), check);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), check);
				EnableWindow(GetDlgItem(hDlg, IDC_ED_TITLESTREAMING_FORMAT), check);
				return FALSE;
			}
		case IDC_BUTTON_FILEDIALOG:
			{
				CString str;

				str.LoadString(IDS_SAVESTREAMDLG);

				CFileDialog FileDialog(FALSE, _T("*.mp3"), _T("notitle.mp3"), OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, str, CWnd::FromHandle(hDlg), 0);
				if (FileDialog.DoModal() == IDOK)
				{
					SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, FileDialog.GetPathName());
				}
				return FALSE;
			}
		case BN_CLICKED:
			break;
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}

	return TRUE;
}

