#include "stdafx.h"
#include "service.h"
#include <api/service/services.h>
#include <bfc/nsguid.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CService::~CService()
{
	while (factories.GetSize() != 0)
	{
		CFactory* pFactory = (CFactory*)factories[0];
		factories.RemoveAt(0);
		delete pFactory;
	}
	delete factory;
}

int CService::_register(waServiceFactory* svc)
{
	wchar_t guidStr[255];
	nsGUID::toCharW(svc->getGuid(), guidStr);
	TRACE(_T("_register %s"), guidStr);
	factories.Add(svc);
	return TRUE;
}

int CService::_deregister(waServiceFactory* svc)
{
	TRACE(_T("_deregister"));

	for (int i = 0; i < factories.GetSize(); i++)
	{
		if (factories[i] == svc)
		{
			factories.RemoveAt(i);
			break;
		}
	}
	return TRUE;
}

int CService::_getNumServices(FOURCC svc_type)
{
	TRACE(_T("_getNumServices"));
	return TRUE;
}

waServiceFactory* CService::_enumService(FOURCC svc_type, int n)
{
	TRACE(_T("_enumService"));
	return factory;
} 

waServiceFactory* CService::_getServiceByGuid(GUID guid)
{
	wchar_t guidStr[255];
	nsGUID::toCharW(guid, guidStr);
	TRACE(_T("_getServiceByGuid %s"), guidStr);
	if (AgaveConfigGUID == guid)
		return factory;
	if (api_playlistmanagerGUID == guid)
		return (waServiceFactory *)&playlist;
	if (applicationApiServiceGuid == guid)
		return (waServiceFactory *)&application;
	for (int i = 0; i < factories.GetSize(); i++)
	{
		if (factories[i]->getGuid() == guid)
			return factories[i];
	}

	if (guid == WaSvc::ACCESSIBILITY)
	{
		TRACE(_T("ACCESSIBILITY"));
	}
	if (guid == WaSvc::ACCESSIBILITYROLESERVER)
	{
		TRACE(_T("ACCESSIBILITYROLESERVER"));
	}
	if (guid == WaSvc::COLLECTION)
	{
		TRACE(_T("COLLECTION"));
	}
	if (guid == WaSvc::CONTEXTCMD)
	{
		TRACE(_T("CONTEXTCMD"));
	}
	if (guid == WaSvc::DB)
	{
		TRACE(_T("DB"));
	}
	if (guid == WaSvc::EVALUATOR)
	{
		TRACE(_T("EVALUATOR"));
	}
	if (guid == WaSvc::FILESELECTOR)
	{
		TRACE(_T("FILESELECTOR"));
	}
	if (guid == WaSvc::ITEMMANAGER)
	{
		TRACE(_T("ITEMMANAGER"));
	}
	if (guid == WaSvc::METADATA)
	{
		TRACE(_T("METADATA"));
	}
	if (guid == WaSvc::MINIBROWSER)
	{
		TRACE(_T("MINIBROWSER"));
	}
	if (guid == WaSvc::OBJECTDIR)
	{
		TRACE(_T("OBJECTDIR"));
	}
	if (guid == WaSvc::PLAYLISTREADER)
	{
		TRACE(_T("PLAYLISTREADER"));
	}
	if (guid == WaSvc::PLAYLISTWRITER)
	{
		TRACE(_T("PLAYLISTWRITER"));
	}
	if (guid == WaSvc::STORAGEVOLENUM)
	{
		TRACE(_T("STORAGEVOLENUM"));
	}
	if (guid == WaSvc::TOOLTIPSRENDERER)
	{
		TRACE(_T("TOOLTIPSRENDERER"));
	}
	if (guid == WaSvc::WINDOWCREATE)
	{
		TRACE(_T("WINDOWCREATE"));
	}
	if (guid == WaSvc::NONE)
	{
		TRACE(_T("NONE"));
	}
	if (guid == WaSvc::UNIQUE)
	{
		TRACE(_T("UNIQUE"));
	}
	if (guid == WaSvc::IMAGELOADER)
	{
		TRACE(_T("IMAGELOADER"));
	}
	if (guid == WaSvc::FONTRENDER)
	{
		TRACE(_T("FONTRENDER"));
	}
	if (guid == WaSvc::STRINGCONVERTER)
	{
		TRACE(_T("STRINGCONVERTER"));
	}
	if (guid == WaSvc::XMLPROVIDER)
	{
		TRACE(_T("XMLPROVIDER"));
	}
	if (guid == WaSvc::REDIRECT)
	{
		TRACE(_T("REDIRECT"));
	}
	if (guid == WaSvc::IMAGEGENERATOR)
	{
		TRACE(_T("IMAGEGENERATOR"));
	}
	if (guid == WaSvc::ACTION)
	{
		TRACE(_T("ACTION"));
	}
	if (guid == WaSvc::SRCCLASSFACTORY)
	{
		TRACE(_T("SRCCLASSFACTORY"));
	}
	if (guid == WaSvc::FILEREADER)
	{
		TRACE(_T("FILEREADER"));
	}
	if (guid == WaSvc::SKINFILTER)
	{
		TRACE(_T("SKINFILTER"));
	}
	if (guid == WaSvc::XUIOBJECT)
	{
		TRACE(_T("XUIOBJECT"));
	}
	if (guid == WaSvc::DROPTARGET)
	{
		TRACE(_T("DROPTARGET"));
	}
	if (guid == WaSvc::SCRIPTOBJECT)
	{
		TRACE(_T("SCRIPTOBJECT"));
	}
	CFactory* pwaServiceFactory = new CFactory(guid);

	_register(pwaServiceFactory);

	return pwaServiceFactory;
}

int CService::_lock(waServiceFactory* owner, void* svcptr)
{
	TRACE(_T("_lock"));
	return TRUE;
}

int CService::_clientLock(void* svcptr)
{
	TRACE(_T("_clientLock"));
	return TRUE;
}

int CService::_release(void* svcptr)
{
	TRACE(_T("_release"));
	return TRUE;
}

const char* CService::_getTypeName(FOURCC svc_type)
{
	TRACE(_T("_getTypeName"));
	return NULL;
}

int CService::_unlock(void* svcptr)
{
	TRACE(_T("_unlock"));
	return TRUE;
}

int CService::_isvalid(FOURCC svctype, waServiceFactory* service)
{
	TRACE(_T("_isvalid"));
	return TRUE;
}
