#ifndef SERVICE_H
#define SERVICE_H

#include "playlist.h"
#include "application.h"
#include "factory.h"
#include <api/service/api_service.h>
#include <bfc/platform/guid.h>

class CService : public api_service
{
	CPlaylist playlist;
	CFactory* factory;
	CApplication application;
	CArray<waServiceFactory*, waServiceFactory*> factories;
public :
	CService()
	{
		factory = new CFactory(AgaveConfigGUID);
	};
	~CService();
	int _register(waServiceFactory* svc);
	int _deregister(waServiceFactory* svc);
	int _getNumServices(FOURCC svc_type);
	waServiceFactory* _enumService(FOURCC svc_type, int n);
	waServiceFactory* _getServiceByGuid(GUID guid);
	int _lock(waServiceFactory* owner, void* svcptr);
	int _clientLock(void* svcptr);
	int _release(void* svcptr);
	const char* _getTypeName(FOURCC svc_type);
	int _unlock(void* svcptr);
	int _isvalid(FOURCC svctype, waServiceFactory* service);
#undef CBCLASS
#define CBCLASS CService
	START_DISPATCH;
	CB(API_SERVICE_SERVICE_REGISTER, _register);
	CB(API_SERVICE_SERVICE_DEREGISTER, _deregister);
	CB(API_SERVICE_SERVICE_GETNUMSERVICES, _getNumServices);
	CB(API_SERVICE_SERVICE_ENUMSERVICE, _enumService);
	CB(API_SERVICE_SERVICE_GETSERVICEBYGUID, _getServiceByGuid);
	CB(API_SERVICE_SERVICE_LOCK, _lock);
	CB(API_SERVICE_SERVICE_CLIENTLOCK, _clientLock);
	CB(API_SERVICE_SERVICE_RELEASE, _release);
	CB(API_SERVICE_SERVICE_GETTYPENAME, _getTypeName);
	CB(API_SERVICE_SERVICE_UNLOCK, _unlock);
	CB(API_SERVICE_ISVALID, _isvalid);
	END_DISPATCH;
#undef CBCLASS
};

#endif